MODULE Project;

IMPORT
  Trace, W := Windows, Cl := Classes, C := Controls, F := Forms, G := Graphics,
  U := Utilites;

TYPE
  Byte         = W.Byte;
  Char         = W.Char;
  Boolean      = W.Boolean;
  Shortint     = W.Shortint;
  Integer      = W.Integer;
  Longint      = W.Longint;
  Real         = W.Real;
  Longreal     = W.Longreal;
  Pointer      = W.Pointer;
  Set	       = W.Set;
  String       = W.String;
  Name         = W.Name;

  Form = OBJECT (F.Form)
  VAR
    timer : Cl.Timer;
    canvas: G.Bitmap;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      width := 800;
      height := 600;
      position := F.poCenterCenter;

      NEW(canvas);
      canvas.SetSize(width,height);

      NEW(timer);
      timer.interval := 25;
      timer.OnTimer  := TimerTimer;
      timer.Enable;
    END Create;

    PROCEDURE Destroy*;
    BEGIN
      canvas.Free;
      Destroy^;
    END Destroy;

    PROCEDURE CreateParams*;
    BEGIN
      CreateParams^;
      canvas.SetSize(width,height);
    END CreateParams;

    PROCEDURE WMSize*(VAR message: Cl.Message);
    BEGIN
      WMSize^(message);
      canvas.SetSize(width,height);
    END WMSize;

    PROCEDURE WMEraseBkgnd*(VAR message: Cl.Message);
    BEGIN
      message.result := 1;
    END WMEraseBkgnd;

    PROCEDURE WMPaint*(VAR message: Cl.Message);
    BEGIN
      Paint;
    END WMPaint;

    PROCEDURE TimerTimer(Sender: Cl.Timer);
    BEGIN
      Paint;
    END TimerTimer;

    PROCEDURE Paint;
    VAR
      dc : W.HDC;
      x  : Integer;
    BEGIN
      dc := W.GetDC(handle);
      canvas.FillRect(0,0,width,height,color);
      FOR x := 0 TO 500 DO
        canvas.AntialiasCircle(U.RandRange(20,width-40),U.RandRange(20,height-40),U.RandRange(5,30),U.Random(0),U.Random(0),TRUE);
      END;
      canvas.Draw(dc,0,0);
      W.ReleaseDC(handle,dc);
    END Paint;

  END Form;

VAR
  f: Form;
BEGIN
  NEW(f,NIL);
  f.Show;
  Cl.Run;
END Project.
