MODULE Extctrls;

IMPORT
  SYSTEM, Trace, W := Windows, Cl := Classes,
  S := Stdctrls, C := Controls, G := Graphics;

CONST
  tbsButton*   = 1;
  tbsSeparator*= 2;

  tbColor*     = TRUE;
  tbGray*      = FALSE;

TYPE
  Char         = W.Char;
  Boolean      = W.Boolean;
  Shortint     = W.Shortint;
  Integer      = W.Integer;
  Longint      = W.Longint;
  Real         = W.Real;
  Longreal     = W.Longreal;
  Pointer      = W.Pointer;
  Set	       = W.Set;
  String       = W.String;
  Name         = W.Name;

  Toolpanel* = OBJECT (C.Control)
  VAR
    header*  : S.Header;
    OnClose* : Cl.NotifyEvent;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      classname    := "Toolpanel";
      width        := 150;
      height       := 250;
      NEW(header,SELF);
      header.OnClose := PanelClose;
    END Create;

    PROCEDURE Destroy*;
    BEGIN
      header := NIL;
      Destroy^;
    END Destroy;

    PROCEDURE CreateParams*;
    BEGIN
      CreateParams^;
      style          := style - W.WS_BORDER;
      header.cscolor := header.closecolor;
    END CreateParams;

    PROCEDURE PanelClose*(Sender: Cl.Object);
    BEGIN
      IF OnClose # NIL THEN OnClose(SELF) END;
    END PanelClose;

    PROCEDURE WMPaint*(VAR message: Cl.Message);
    BEGIN
    END WMPaint;

    PROCEDURE WMEraseBkgnd*(VAR message: Cl.Message);
    BEGIN
      message.result := 0;
    END WMEraseBkgnd;

  END Toolpanel;

  Toolbutton* = OBJECT (C.Control)
  VAR
    btnstyle*  : Shortint;
    imageindex*: Longint;

    sepwidth   : Longint;
    disablecolor: Longint;
    leavecolor : Longint;
    entercolor : Longint;
    downcolor  : Longint;
    colorizecl : Longint;
    offset     : W.Point;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      width    := 23;
      height   := 22;
      sepwidth := 5;

      classname    := "Toolbutton";
      IF Parent # NIL THEN
        color  := Parent.color;
      END;

      btnstyle   := tbsButton;

      offset.x   := 0;
      offset.y   := 0;

    END Create;

    PROCEDURE CreateParams*;
    BEGIN
      CreateParams^;
      style     := style - W.WS_BORDER;
    END CreateParams;

    PROCEDURE SetRegion;
    VAR
      reg1,reg2: W.HRgn;
    BEGIN
      reg1 := W.CreateRectRgn(0,0,width,height);
      IF reg1 # 0 THEN
        reg2 := W.CreateRoundRectRgn(0,0,width+1,height+1,2,2);
        IF reg2 # 0 THEN
          W.CombineRgn(reg1,reg1,reg2,W.RGN_AND);
          W.DeleteObject(reg2);
        END;
        W.SetWindowRgn(handle,reg1,W.True);
        W.DeleteObject(reg1);
      END;
    END SetRegion;

    PROCEDURE WMShow*;
    BEGIN
      WMShow^;
      IF btnstyle = tbsButton THEN
        SetRegion;
      ELSIF btnstyle = tbsSeparator THEN
        IF width # sepwidth THEN
          width := sepwidth;
          W.MoveWindow(handle,left,top,width,height,0);
        END;
      END;
    END WMShow;

    PROCEDURE WMDisable*;
    BEGIN
      WMDisable^;
      IF btnstyle = tbsButton THEN
        color  := disablecolor;
      END;
    END WMDisable;

    PROCEDURE WMEnable*;
    BEGIN
      WMEnable^;
      IF btnstyle = tbsButton THEN
        color  := leavecolor;
      END;
    END WMEnable;

    PROCEDURE WMMouseLeave*;
    BEGIN
      WMMouseLeave^;
      IF btnstyle = tbsButton THEN
        color  := leavecolor;
      END;
    END WMMouseLeave;

    PROCEDURE WMMouseEnter*;
    BEGIN
      WMMouseEnter^;
      IF btnstyle = tbsButton THEN
        color  := entercolor;
      END;
    END WMMouseEnter;

    PROCEDURE WMMouseDown*(VAR message: Cl.Message);
    BEGIN
      WMMouseDown^(message);
      IF btnstyle = tbsButton THEN
        color  := downcolor;
        offset.x    := 1;
        offset.y    := 1;
      END;
    END WMMouseDown;

    PROCEDURE WMMouseUp*(VAR message: Cl.Message);
    BEGIN
      WMMouseUp^(message);
      IF (btnstyle = tbsButton) THEN
        color  := entercolor;
        offset.x    := 0;
        offset.y    := 0;
      END;
    END WMMouseUp;

    PROCEDURE WMPaint*(VAR message: Cl.Message);
    VAR
      pen   : W.HPen;
      dc    : W.HDC;
      parent: Toolbar;
    BEGIN
      dc := W.GetDC(handle);
      IF btnstyle = tbsButton THEN
        parent := owner(Toolbar);
        IF (parent # NIL) & (parent.imagelist # NIL) & (parent.imagelist.count > 0) THEN
          IF (imageindex >= 0) & (imageindex < parent.imagelist.count) THEN
            IF ~ enabled THEN
              color  := parent.color;
              parent.imagelist.Draw(dc,(width - parent.imagelist.width) DIV 2 + offset.x + 1,(height - parent.imagelist.height) DIV 2 + offset.y,imageindex,color,colorizecl,TRUE);
            ELSE
              parent.imagelist.Draw(dc,(width - parent.imagelist.width) DIV 2 + offset.x + 1,(height - parent.imagelist.height) DIV 2 + offset.y,imageindex,color,0,FALSE);
            END;
          END;
        END;
      ELSE
        pen := W.CreatePen(W.PS_SOLID,1,entercolor);
        W.SelectObject(dc, pen);
        W.MoveToEx(dc,width DIV 2,2,NIL);
        W.LineTo(dc,width DIV 2,height-2);
        W.DeleteObject(pen);
      END;
      W.ReleaseDC(handle,dc);
    END WMPaint;

  END Toolbutton;

  Toolbar* = OBJECT (C.Control)
  VAR
    imagelist*   : G.Imagelist;

    leavecolor*  : Longint;
    disablecolor*: Longint;
    entercolor*  : Longint;
    downcolor*   : Longint;
    colorizecl*  : Longint;

    btnleft      : Longint;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      classname    := "Toolbar";
      caption      := "";
      align        := Cl.alTop;
      height       := 26;
      btnleft      := 2;

      disablecolor := color;
      leavecolor   := 0E8E8E8H;
      entercolor   := 0D2D2D2H;
      downcolor    := 0DDDDDDH;
      colorizecl   := 0404040H;

    END Create;

    PROCEDURE CreateParams*;
    BEGIN
      CreateParams^;
      style   := style - W.WS_BORDER;
    END CreateParams;

    PROCEDURE AddButton*(name: String; btnstyle: Shortint): Toolbutton;
    VAR
      btn: Toolbutton;
    BEGIN
      NEW(btn,SELF);
      btn.top := (height - btn.height) DIV 2;
      btn.left := btnleft;
      btn.btnstyle := btnstyle;

      btn.disablecolor := disablecolor;
      btn.leavecolor   := leavecolor;
      btn.entercolor   := entercolor;
      btn.downcolor    := downcolor;
      btn.colorizecl   := colorizecl;

      IF btnstyle = tbsSeparator THEN
        btn.width := btn.sepwidth;
      END;
      btnleft  := btnleft + btn.width + 1;
      RETURN btn;
    END AddButton;

    PROCEDURE WMSize*(VAR message: Cl.Message);
    VAR
      i: Longint;
    BEGIN
      WMSize^(message);
      IF controls # NIL THEN
        FOR i := 0 TO controls.count - 1 DO
          IF controls.list[i](C.Control).visible & (controls.list[i](C.Control).left + controls.list[i](C.Control).width > width) THEN
            controls.list[i](C.Control).visible := FALSE;
          ELSIF ~ controls.list[i](C.Control).visible & (controls.list[i](C.Control).left + controls.list[i](C.Control).width <= width) THEN
            controls.list[i](C.Control).visible := TRUE;
          END;
        END;
      END;
    END WMSize;

    PROCEDURE WMPaint*(VAR message: Cl.Message);
    BEGIN
    END WMPaint;

  END Toolbar;

  Pagecontrol* = OBJECT (C.Control)
  VAR
    tabcontrol : S.Tabcontrol;
    bitmap     : G.Bitmap;

    activepage*: C.Control;
    count*     : Longint;

    tabcolor*     : Longint;
    tabframe*     : Longint;
    tableave*     : Longint;
    tabenter*     : Longint;
    tabdown*      : Longint;
    tabfrenter*   : Longint;
    activeframe*  : Longint;
    activecolor*  : Longint;

    textcolor*    : Longint;
    activetext*   : Longint;
    updowncolor*  : Longint;
    updownframe*  : Longint;
    updownenter*  : Longint;
    updowndown*   : Longint;
    closecolor*   : Longint;
    closeenter*   : Longint;

    OnTabClose*   : Cl.NotifyEvent;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      classname    := "Pagecontrol";
      width        := 250;
      height       := 250;
      activepage   := NIL;
      NEW(tabcontrol,SELF);
      tabcontrol.align := Cl.alTop;
      tabcontrol.OnTabClose    := TabClose;
      tabcontrol.OnTabActivate := TabActivate;
      count        := 0;

      tabcolor     := 0E8E8E8H;
      tabframe     := 0AAAAAAH;
      tableave     := 0E8E8E8H;
      tabenter     := 0D2D2D2H;
      tabfrenter   := G.clMedGray;
      tabdown      := 0DDDDDDH;
      activeframe  := G.clGray;
      activecolor  := G.clWhite;

      textcolor    := tabfrenter;
      activetext   := 0444444H;

      updowncolor  := tabcolor;
      updownframe  := tabframe;
      updownenter  := tabenter;
      updowndown   := tabdown;

      closecolor   := G.clSilver;
      closeenter   := G.clGray;

      NEW(bitmap);
    END Create;

    PROCEDURE CreateParams*;
    BEGIN
      CreateParams^;
      tabcontrol.color       := color;
      tabcontrol.tabcolor    := tabcolor;
      tabcontrol.tabframe    := tabframe;
      tabcontrol.tableave    := tableave;
      tabcontrol.tabenter    := tabenter;
      tabcontrol.tabfrenter  := tabfrenter;
      tabcontrol.tabdown     := tabdown;
      tabcontrol.activeframe := activeframe;
      tabcontrol.closecolor  := closecolor;
      tabcontrol.closeenter  := closeenter;
      tabcontrol.textcolor   := textcolor;
      tabcontrol.activetext  := activetext;

      tabcontrol.updowncolor := updowncolor;
      tabcontrol.updownframe := updownframe;
      tabcontrol.updownenter := updownenter;
      tabcontrol.updowndown  := updowndown;
    END CreateParams;

    PROCEDURE Destroy*;
    BEGIN
      activepage := NIL;
      tabcontrol := NIL;
      bitmap.Free;
      Destroy^;
    END Destroy;

    PROCEDURE SetActivePage(VAR page: C.Control);
    BEGIN
      IF activepage # NIL THEN activepage.visible := FALSE; END;
      page.visible := TRUE;
      activepage   := page;
      Resize;
    END SetActivePage;

    PROCEDURE FindByName*(name: Name): Longint;
    VAR
      i: Longint;
    BEGIN
      IF (tabcontrol # NIL) & (tabcontrol.tabs # NIL) & (tabcontrol.tabs.count > 0) THEN
        FOR i := 0 TO tabcontrol.tabs.count - 1 DO
          IF tabcontrol.tabs.list[i](S.Tab).name = name THEN
            RETURN i;
          END;
        END;
      END;
      RETURN -1;
    END FindByName;

    PROCEDURE NewPage*(name: Name);
    VAR
      page: C.Control;
    BEGIN
      NEW(page,SELF);
      tabcontrol.AddTab(name,page);
      INC(count);
      page.color := tabcontrol.activecolor;
      SetActivePage(page);
      Resize;
      W.InvalidateRect(handle,NIL,W.False);
    END NewPage;

    PROCEDURE TabClose(Sender: S.Tab);
    BEGIN
      DEC(count);
      W.InvalidateRect(handle,NIL,W.False);
      IF OnTabClose # NIL THEN OnTabClose(NIL) END;
    END TabClose;

    PROCEDURE TabActivate(Sender: S.Tab);
    BEGIN
      IF Sender.control # NIL THEN
        SetActivePage(Sender.control);
      END;
    END TabActivate;

    PROCEDURE Resize*;
    BEGIN
      IF activepage # NIL THEN
        activepage.left  := tabcontrol.offset - 5;
        activepage.top   := tabcontrol.height;
        activepage.width := width  - tabcontrol.offset;
        activepage.height:= height - tabcontrol.height - 5;
      END;
    END Resize;

    PROCEDURE WMSize*(VAR message: Cl.Message);
    BEGIN
      WMSize^(message);
      Resize;
    END WMSize;

    PROCEDURE WMPaint*(VAR message: Cl.Message);
    VAR
      dc  : W.HDC;
      pen : W.HPen;
    BEGIN
      IF (tabcontrol # NIL) & (tabcontrol.tabs # NIL) & (tabcontrol.tabs.count > 0) THEN
        dc := W.GetDC(handle);
        pen := W.CreatePen(W.PS_SOLID,1,activeframe);
        W.SelectObject(dc, pen);
        IF width > tabcontrol.offset THEN
          W.MoveToEx(dc,tabcontrol.offset - 5 - 1,tabcontrol.height,NIL);
          W.LineTo(dc,tabcontrol.offset - 5 - 1,height - 5);
          W.MoveToEx(dc,tabcontrol.offset - 5,height - 5,NIL);
          W.LineTo(dc,width - tabcontrol.offset + 5,height - 5);
          W.MoveToEx(dc,width - tabcontrol.offset + 5,height - 5 - 1,NIL);
          W.LineTo(dc,width - tabcontrol.offset + 5,tabcontrol.height - 1);
        END;
        W.DeleteObject(pen);
        W.ReleaseDC(handle,dc);
      END;
    END WMPaint;

  END Pagecontrol;

  Scrollbox* = OBJECT (C.Control)
  VAR
    hscroll*: S.Scrollbar;
    vscroll*: S.Scrollbar;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      classname    := "Scrollbox";
      width        := 250;
      height       := 250;
      NEW(vscroll,SELF);
      vscroll.kind  := S.sbVertical;
      vscroll.align := Cl.alRight;
      vscroll.OnChange := ScrollChange;
      (*vscroll.visible := FALSE;*)
      NEW(hscroll,SELF);
      hscroll.align := Cl.alBottom;
      hscroll.indentcorner := 16;
      (*hscroll.visible := FALSE;*)
      hscroll.OnChange := ScrollChange;
    END Create;

    PROCEDURE AfterCreate*;
    BEGIN
      AfterCreate^;
      W.SetWindowPos(
        vscroll.handle, W.HWND_TOP,
        0, 0, 0, 0,
        W.SWP_NOMOVE + W.SWP_NOSIZE + W.SWP_NOACTIVATE
      );
      W.SetWindowPos(
        hscroll.handle, W.HWND_TOP,
        0, 0, 0, 0,
        W.SWP_NOMOVE + W.SWP_NOSIZE + W.SWP_NOACTIVATE
      );
    END AfterCreate;

    PROCEDURE Destroy*;
    BEGIN
      Destroy^;
    END Destroy;

    PROCEDURE ScrollChange*(Sender: Cl.Object);
    BEGIN
    END ScrollChange;

  END Scrollbox;

END Extctrls.

