MODULE Forms;

IMPORT
  SYSTEM, Trace, W := Windows, Cl := Classes, C := Controls,
  M := Menus;

CONST
  poCustom*        = 0;
  poLeftTop*       = 1;
  poLeftCenter*    = 2;
  poLeftBottom*    = 3;
  poCenterTop*     = 4;
  poCenterCenter*  = 5;
  poCenterBottom*  = 6;
  poRightTop*      = 7;
  poRightCenter*   = 8;
  poRightBottom*   = 9;

TYPE
  Byte         = W.Byte;
  Char         = W.Char;
  Boolean      = W.Boolean;
  Shortint     = W.Shortint;
  Integer      = W.Integer;
  Longint      = W.Longint;
  Real         = W.Real;
  Longreal     = W.Longreal;
  Pointer      = W.Pointer;
  Set	       = W.Set;
  String       = W.String;
  Name         = W.Name;

  Form* = OBJECT (C.Control)

    position*: Longint;
    mainmenu*: M.Mainmenu;
    icon*    : Name;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      classname    := "Form";
      visible      := FALSE;
      icon         := "";
      left         := 30;
      top          := 30;
      width        := 320;
      height       := 240;
      position     := poCustom;
      property.AddLongint("position",0);
      property.AddString("icon",icon);
      property.Sort;
    END Create;

    PROCEDURE CreateParams*;
    BEGIN
      CreateParams^;
      style    := W.WS_OVERLAPPEDWINDOW + W.WS_CLIPCHILDREN + W.WS_CLIPSIBLINGS + W.WS_POPUP;
      exstyle  := W.WS_EX_APPWINDOW + W.WS_EX_COMPOSITED;
      wndstyle := wndstyle - W.CS_VREDRAW - W.CS_HREDRAW - W.CS_DBLCLKS;
      SetPosition;
    END CreateParams;

    PROCEDURE SetPosition;
    BEGIN
      CASE position OF
      |  poLeftTop       : left :=0; top :=0;
      |  poLeftCenter    : left :=0; top := (Cl.screen.height - height) DIV 2;
      |  poLeftBottom    : left :=0; top := Cl.screen.height - height;
      |  poCenterTop     : left := (Cl.screen.width - width) DIV 2; top := 0;
      |  poCenterCenter  : left := (Cl.screen.width - width) DIV 2; top := (Cl.screen.height - height) DIV 2;
      |  poCenterBottom  : left := (Cl.screen.width - width) DIV 2; top := Cl.screen.height - height;
      |  poRightTop      : left := Cl.screen.width - width; top := 0;
      |  poRightCenter   : left := Cl.screen.width - width; top := (Cl.screen.height - height) DIV 2;
      |  poRightBottom   : left := Cl.screen.width - width; top := Cl.screen.height - height;
      ELSE
      END;
    END SetPosition;

    PROCEDURE CheckProperty*;
    VAR
      i   : Longint;
      prop: Cl.Property;
    BEGIN

      prop := property.GetProperty("position");
      IF position # prop.longint THEN
        SetPosition;
        property.AddLongint("position"  ,position);
      END;

      prop := property.GetProperty("icon");
      IF icon # prop.string THEN
        i := W.GetClassLong(handle,W.GCL_HICON);
        IF i # 0 THEN W.DeleteObject(i) END;
        i := W.LoadImage(handle,SYSTEM.ADR(icon),W.IMAGE_ICON,0,0,W.LR_LOADFROMFILE);
        W.SetClassLong(handle,W.GCL_HICON,i);
        property.AddString("icon",icon);
      END;

      property.modified := {};
      CheckProperty^;
    END CheckProperty;

    PROCEDURE WMActivate*(VAR message: Cl.Message);
    BEGIN
      Cl.activeform := handle;
    END WMActivate;

    PROCEDURE Close*;
    VAR
      message: Cl.Message;
    BEGIN
      message.msg := W.WM_CLOSE;
      WindowProc(message);
    END Close;

    PROCEDURE FormUpdate*;
    BEGIN
    END FormUpdate;

    PROCEDURE Update*;
    BEGIN
      Update^;
      FormUpdate;
    END Update;

    PROCEDURE WindowProc*(VAR message: Cl.Message);
    BEGIN
      CASE message.msg OF
      |  W.WM_DESTROY     : ;
      ELSE
        WindowProc^(message);
      END;
    END WindowProc;

  END Form;

END Forms.
