MODULE Stdctrls;

IMPORT
  SYSTEM, W := Windows, U := Utilites, Cl := Classes,
  C := Controls, G := Graphics;

CONST
  sbVertical*  = 1;
  sbHorizontal*= 2;

TYPE
  Byte         = W.Byte;
  Char         = W.Char;
  Boolean      = W.Boolean;
  Shortint     = W.Shortint;
  Integer      = W.Integer;
  Longint      = W.Longint;
  Real         = W.Real;
  Longreal     = W.Longreal;
  Pointer      = W.Pointer;
  Set	       = W.Set;
  String       = W.String;
  Name         = W.Name;

  Panel* = OBJECT (C.Control)

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      classname    := "Panel";
      width        := 150;
      height       := 250;
      color        := G.clBtnFace;
    END Create;

    PROCEDURE CreateParams*;
    BEGIN
      CreateParams^;
      style     := style - W.WS_BORDER;
    END CreateParams;

    PROCEDURE WMPaint*(VAR message: Cl.Message);
    VAR
      dc    : W.HDC;
      size  : W.Size;
    BEGIN
      dc := W.GetDC(handle);
      W.SetBkMode(dc,W.TRANSPARENT);
      W.SetTextColor(dc,font.color);
      W.SelectObject(dc, font.handle);
      W.GetTextExtentPoint32(dc,SYSTEM.ADR(caption),U.Length(caption),size);
      W.ExtTextOut(dc,(width - size.cx) DIV 2, (height - size.cy) DIV 2, W.ETO_CLIPPED, NIL, SYSTEM.ADR(caption),U.Length(caption), NIL);
      G.Frame3D(dc,0,0,width-1,height-1,G.clWhite,G.clGray);
      W.ReleaseDC(handle,dc);
    END WMPaint;

    PROCEDURE WMEraseBkgnd*(VAR message: Cl.Message);
    BEGIN
      message.result := 0;
    END WMEraseBkgnd;

  END Panel;

  Header* = OBJECT (C.Customcontrol)
  VAR
    textcolor*  : Longint;
    closecolor* : Longint;
    closeenter* : Longint;
    closedown*  : Longint;

    closerect   : W.Rect;
    cscolor*    : Longint;
    csactive    : Boolean;

    OnClose*    : Cl.NotifyEvent;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      classname    := "Header";
      width        := 150;
      height       := 27;
      align        := Cl.alTop;
      color        := 0D2D2D2H;
      textcolor    := 0444444H;

      closecolor   := G.clMedGray;
      closeenter   := G.clGray;
      closedown    := G.clSilver;
      cscolor      := closecolor;
      csactive     := FALSE;
    END Create;

    PROCEDURE Destroy*;
    BEGIN
      Destroy^;
    END Destroy;

    PROCEDURE WMMouseLeave*;
    BEGIN
      WMMouseLeave^;
      cscolor      := closecolor;
      csactive     := FALSE;
      W.InvalidateRect(handle,closerect,W.False);
    END WMMouseLeave;

    PROCEDURE WMMouseDown*(VAR message: Cl.Message);
    BEGIN
      WMMouseDown^(message);
      IF csactive THEN
        cscolor      := closedown;
        W.InvalidateRect(handle,closerect,W.False);
      END;
    END WMMouseDown;

    PROCEDURE WMMouseMove*(VAR message: Cl.Message);
    VAR
      x,y,c : Longint;
    BEGIN
      WMMouseMove^(message);
      x := U.LoWord(message.lparam);
      y := U.HiWord(message.lparam);
      c := cscolor;

      IF U.XYInRect(x,y,closerect) THEN
        IF ~ mousedown THEN
          cscolor      := closeenter;
        END;
        csactive     := TRUE;
      ELSE
        IF ~ mousedown THEN
        cscolor      := closecolor;
        END;
        csactive     := FALSE;
      END;

      IF c # cscolor THEN
        W.InvalidateRect(handle,closerect,W.False);
      END;
    END WMMouseMove;

    PROCEDURE WMMouseUp*(VAR message: Cl.Message);
    BEGIN
      WMMouseUp^(message);
      IF csactive THEN
        IF OnClose # NIL THEN OnClose(SELF) END;
      END;
    END WMMouseUp;

    PROCEDURE DrawClose(rect: W.Rect);
    VAR
      cx,cy,r, offset: Longint;
    BEGIN
      r := (rect.right - rect.left) DIV 2;
      cx := rect.right  - r;
      cy := rect.bottom - r;
      canvas.AntialiasCircle(cx,cy,r,cscolor,cscolor,TRUE);

      offset := 5;
      canvas.Line(cx - r + offset,cy - r + offset, cx + r - offset, cy + r - offset,color);
      canvas.Line(cx - r + offset,cy - r + offset + 1, cx + r - offset - 1, cy + r - offset,color);
      canvas.Line(cx - r + offset +1,cy - r + offset, cx + r - offset, cy + r - offset - 1,color);

      canvas.Line(cx + r - offset,cy - r + offset, cx - r + offset, cy + r - offset,color);
      canvas.Line(cx + r - offset,cy - r + offset +1, cx - r + offset + 1, cy + r - offset,color);
      canvas.Line(cx + r - offset - 1,cy - r + offset, cx - r + offset, cy + r - offset - 1,color);

    END DrawClose;

    PROCEDURE Paint*;
    VAR
      r,i: Longint;
    BEGIN
      i := 0;

      IF (owner # NIL) & (caption # owner.caption) THEN
        caption := owner.caption;
      END;
      canvas.font.color := textcolor;
      canvas.TextOut(i + 5,(height - canvas.font.height) DIV 2 - 1,caption);

      r := (height - 10) DIV 2;
      closerect.left   := width - r*2 - 5;
      closerect.top    := height DIV 2 - r;
      closerect.right  := closerect.left + r*2;
      closerect.bottom := closerect.top  + r*2;
      DrawClose(closerect);
    END Paint;

  END Header;

  Splitter* = OBJECT (C.Control)
  VAR
    bitmap       : G.Bitmap;
    shadowcolor* : Longint;

    curwe        : W.HCursor;
    curns        : W.HCursor;
    cursor       : W.HCursor;

    start        : W.Point;

    leftclient   : C.Control;
    topclient    : C.Control;
    rightclient  : C.Control;
    bottomclient : C.Control;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      classname    := "Splitter";
      width        := 4;
      height       := 250;
      color        := G.clSilver;
      shadowcolor  := G.clMedGray;
      align        := Cl.alRight;
      NEW(bitmap);
      curwe        := W.LoadCursor(0,SYSTEM.VAL(W.LPSTR,W.IDC_SIZEWE));
      curns        := W.LoadCursor(0,SYSTEM.VAL(W.LPSTR,W.IDC_SIZENS));
      cursor       := W.LoadCursor(0,SYSTEM.VAL(W.LPSTR,W.IDC_ARROW));
    END Create;

    PROCEDURE Destroy*;
    BEGIN
      bitmap.Free;
      Destroy^;
    END Destroy;

    PROCEDURE CreateParams*;
    BEGIN
      CreateParams^;
      style := style - W.WS_BORDER;
      CASE align OF
      |  Cl.alLeft,Cl.alRight: bitmap.SetSize(width,4*10);
      |  Cl.alTop,Cl.alBottom: bitmap.SetSize(4*10,height);
      ELSE
      END;
    END CreateParams;

    PROCEDURE SetCursor;
    BEGIN
      CASE align OF
      |  Cl.alLeft,Cl.alRight: W.SetClassLong(handle,W.GCL_HCURSOR,curwe);
      |  Cl.alTop,Cl.alBottom: W.SetClassLong(handle,W.GCL_HCURSOR,curns);
      ELSE
      END;
    END SetCursor;

    PROCEDURE WMMouseLeave*;
    BEGIN
      WMMouseLeave^;
      W.SetCursor(cursor);
    END WMMouseLeave;

    PROCEDURE WMMouseEnter*;
    BEGIN
      WMMouseEnter^;
      SetCursor;
    END WMMouseEnter;

    PROCEDURE WMMouseDown*(VAR message: Cl.Message);
    VAR
      i,index: Longint;
      flag   : Boolean;
    BEGIN
      WMMouseDown^(message);
      SetCursor;
      start.x := U.LoWord(message.lparam);
      start.y := U.HiWord(message.lparam);
      IF (owner # NIL) & (owner.controls # NIL) & (owner.controls.count > 0) THEN
        index := owner.controls.IndexOf(SELF);
        i := index;
        flag := FALSE;
        IF i # -1 THEN
          IF (align # Cl.alNone) & (align # Cl.alClient) THEN

            WHILE ~ flag & (i >= 0) DO
              IF (SELF # owner.controls.list[i](C.Control))
              &  owner.controls.list[i](C.Control).visible
              &  (owner.controls.list[i](C.Control).align = align) THEN
                flag := TRUE;
                CASE align OF
                |  Cl.alLeft   : leftclient := owner.controls.list[i](C.Control);
                |  Cl.alRight  : rightclient := owner.controls.list[i](C.Control);
                |  Cl.alTop    : topclient := owner.controls.list[i](C.Control);
                |  Cl.alBottom : bottomclient := owner.controls.list[i](C.Control);
                ELSE
                END;
              END;
              DEC(i);
            END;

          ELSE
            start.x := 0;
            start.y := 0;
          END;
        END;
      END;
    END WMMouseDown;

    PROCEDURE WMMouseMove*(VAR message: Cl.Message);
    VAR
      x,y : Longint;
      rect: W.Rect;
    BEGIN
      WMMouseMove^(message);
      IF mousedown THEN
        x := U.LoWord(message.lparam);
        y := U.HiWord(message.lparam);
        IF (align # Cl.alNone) & (align # Cl.alClient) THEN
          IF owner # NIL THEN
            W.GetClientRect(owner.handle,rect);
            IF leftclient # NIL THEN
              leftclient.width := leftclient.width + x - start.x;
              IF leftclient.width < 0 THEN leftclient.width := 0 END;
              IF leftclient.width > (rect.right - rect.left) - width THEN leftclient.width := (rect.right - rect.left) - width END;
            END;
            IF rightclient # NIL THEN
              rightclient.width := rightclient.width - x + start.x;
              IF rightclient.width < 0 THEN rightclient.width := 0 END;
              IF rightclient.width > (rect.right - rect.left) - width THEN rightclient.width := (rect.right - rect.left) - width END;
            END;
            IF topclient # NIL THEN
              topclient.height := topclient.height + y - start.y;
              IF topclient.height < 0 THEN topclient.height := 0 END;
              IF topclient.height > (rect.bottom - rect.top) - height THEN topclient.height := (rect.bottom - rect.top) - height END;
            END;
            IF bottomclient # NIL THEN
              bottomclient.height := bottomclient.height - y + start.y;
              IF bottomclient.height < 0 THEN bottomclient.height := 0 END;
              IF bottomclient.height > (rect.bottom - rect.top) - height THEN bottomclient.height := (rect.bottom - rect.top) - height END;
            END;
            owner.ReAlign;
          END;
        END;
      END;
    END WMMouseMove;

    PROCEDURE WMMouseUp*(VAR message: Cl.Message);
    BEGIN
      WMMouseUp^(message);
      SetCursor;
      start.x      := 0;
      start.y      := 0;
      leftclient   := NIL;
      topclient    := NIL;
      rightclient  := NIL;
      bottomclient := NIL;
    END WMMouseUp;

    PROCEDURE WMPaint*(VAR message: Cl.Message);
    VAR
      dc : W.HDC;
      i  : Longint;
    BEGIN

      dc := W.GetDC(handle);
      bitmap.FillRect(0,0,bitmap.width,bitmap.height,color);

      FOR i := 0 TO 10 DO
        CASE align OF
        |  Cl.alLeft,Cl.alRight: bitmap.FillRect(bitmap.width DIV 2-1,i*4,bitmap.width DIV 2 + 1,i*4+2,shadowcolor);
        |  Cl.alTop,Cl.alBottom: bitmap.FillRect(i*4, bitmap.height DIV 2-1,i*4+2,bitmap.height DIV 2 + 1,shadowcolor);
        ELSE
        END;
      END;

      CASE align OF
      |  Cl.alLeft,Cl.alRight: bitmap.Draw(dc,0,(height - bitmap.height) DIV 2);
      |  Cl.alTop,Cl.alBottom: bitmap.Draw(dc,(width - bitmap.width) DIV 2,0);
      ELSE
      END;

      W.ReleaseDC(handle,dc);
    END WMPaint;

    PROCEDURE WMEraseBkgnd*(VAR message: Cl.Message);
    BEGIN
      message.result := 0;
    END WMEraseBkgnd;

  END Splitter;

  ColorForThumb* = RECORD
    color*: Longint;
    frame*: G.SmallPack;
  END;

  ColorForScroll* = RECORD
    thumb*: ColorForThumb;
    arrow*: G.ExtPack;
    page* : ColorForThumb;
  END;

  Scrollbar* = OBJECT (C.Customcontrol)
  VAR
    kind*          : Shortint;
    min*           : Longint;
    max*           : Longint;
    pagesize*      : Longint;
    position*      : Longint;

    thumbradius*   : Longint;

    colorfor*      : ColorForScroll;

    arupcolor      : Longint;
    ardowncolor    : Longint;

    in             : W.Rect;
    inup           : W.Rect;
    indown         : W.Rect;
    inthumb        : W.Rect;
    incorner       : W.Rect;
    inpageup       : W.Rect;
    inpagedown     : W.Rect;

    indentcorner*  : Longint;

    downonthumb    : Boolean;
    downonup       : Boolean;
    downondown     : Boolean;
    downonpageup   : Boolean;
    downonpagedown : Boolean;
    dragoffset     : Longint;

    pointswidth    : Longint;

    timer          : Cl.Timer;

    OnChange*      : Cl.NotifyEvent;

    page           : Longint;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      classname      := "Exscrollbar";
      width          := 250;
      height         := 16;
      kind           := sbHorizontal;

      min            := 0;
      max            := 100;
      pagesize       := 20;
      position       := 0;
      page           := -1;

      indentcorner   := 0;

      downonthumb    := FALSE;
      downonup       := FALSE;
      downondown     := FALSE;
      downonpageup   := FALSE;
      downonpagedown := FALSE;
      dragoffset     := 0;

      pointswidth    := 3*3;
      thumbradius    := 7;

      color                     := G.clHiGray55;
      colorfor.page.color       := G.clHiGray45;

      colorfor.thumb.color       := G.clHiGray50;
      colorfor.thumb.frame.color := G.clHiGray30;
      colorfor.thumb.frame.light := G.clHiGray10;

      colorfor.arrow.color       := G.clGray60;
      colorfor.arrow.entered     := G.clGray90;
      colorfor.arrow.pressed     := G.clGray30;

      NEW(timer);
      timer.interval := 50;
      timer.OnTimer  := TimerTimer;
    END Create;

    PROCEDURE Destroy*;
    BEGIN
      timer.Free;
      Destroy^;
    END Destroy;

    PROCEDURE CreateParams*;
    BEGIN
      IF kind # sbHorizontal THEN U.Swap(width,height); END;
      CreateParams^;
      arupcolor      := colorfor.arrow.color;
      ardowncolor    := colorfor.arrow.color;
    END CreateParams;

    PROCEDURE WMMouseLeave*;
    BEGIN
      WMMouseLeave^;
      arupcolor      := colorfor.arrow.color;
      ardowncolor    := colorfor.arrow.color;
      W.InvalidateRect(handle,NIL,W.False);
    END WMMouseLeave;

    PROCEDURE WMMouseDown*(VAR message: Cl.Message);
    VAR
      x,y : Longint;
    BEGIN
      WMMouseDown^(message);
      x := U.LoWord(message.lparam);
      y := U.HiWord(message.lparam);

      downonthumb    := U.XYInRect(x,y,inthumb);
      downonup       := U.XYInRect(x,y,inup);
      downondown     := U.XYInRect(x,y,indown);
      downonpageup   := U.XYInRect(x,y,inpageup);
      downonpagedown := U.XYInRect(x,y,inpagedown);

      IF kind = sbHorizontal THEN
        dragoffset:= x-inthumb.left;
      ELSE
        dragoffset:= y-inthumb.top;
      END;

      IF    downondown     THEN ardowncolor := colorfor.arrow.pressed; ScrollBy(1);
      ELSIF downonup       THEN arupcolor   := colorfor.arrow.pressed; ScrollBy(-1)
      ELSIF downonpagedown THEN ScrollBy(pagesize);
      ELSIF downonpageup   THEN ScrollBy(-pagesize);
      END;

      IF mousedown & (downondown OR downonup OR downonpagedown OR downonpageup) THEN
        timer.Enable;
      ELSE
        timer.Disable;
      END;

    END WMMouseDown;

    PROCEDURE WMMouseMove*(VAR message: Cl.Message);
    VAR
      x,y : Longint;
    BEGIN
      WMMouseMove^(message);
      x := U.LoWord(message.lparam);
      y := U.HiWord(message.lparam);
      IF downonthumb THEN
        DoUpdatePosOnDrag(x,y);
      END;
      IF U.XYInRect(x,y,inup) THEN
        arupcolor   := colorfor.arrow.entered;
        W.InvalidateRect(handle,inup,W.False);
      ELSIF U.XYInRect(x,y,indown) THEN
        ardowncolor := colorfor.arrow.entered;
        W.InvalidateRect(handle,indown,W.False);
      ELSE
        arupcolor      := colorfor.arrow.color;
        ardowncolor    := colorfor.arrow.color;
        W.InvalidateRect(handle,NIL,W.False);
      END;
    END WMMouseMove;

    PROCEDURE WMMouseUp*(VAR message: Cl.Message);
    BEGIN
      WMMouseUp^(message);
      timer.Disable;
      downonthumb    := FALSE;
      downonup       := FALSE;
      downondown     := FALSE;
      downonpageup   := FALSE;
      downonpagedown := FALSE;
      arupcolor      := colorfor.arrow.color;
      ardowncolor    := colorfor.arrow.color;
      W.InvalidateRect(handle,NIL,W.False);
    END WMMouseUp;

    PROCEDURE TimerTimer(Sender: Cl.Timer);
    VAR
      p: W.Point;
    BEGIN
      IF timer.delay > 500 DIV timer.interval THEN
        W.GetCursorPos(p);
        W.ScreenToClient(handle,p);
        IF downondown & U.PtInRect(indown,p) THEN
          ScrollBy(1);
        ELSIF downonup & U.PtInRect(inup,p) THEN
          ScrollBy(-1);
        ELSIF downonpagedown & U.PtInRect(inpagedown,p) THEN
          ScrollBy(pagesize);
        ELSIF downonpageup & U.PtInRect(inpageup,p) THEN
          ScrollBy(-pagesize);
        END;
      END;
    END TimerTimer;

    PROCEDURE SetPos(value: Longint);
    BEGIN
      value:= U.Min(value,max);
      value:= U.Max(value,min);
      IF position # value THEN
        position:= value;
        W.InvalidateRect(handle,NIL,W.False);
        IF OnChange # NIL THEN OnChange(SELF) END;
      END;
    END SetPos;

    PROCEDURE ScrollBy*(delta: Longint);
    VAR
      n: Longint;
    BEGIN
      n := position;
      INC(n,delta);
      IF (delta > 0) THEN
        n:= U.Min(n,max - pagesize);
      END;
      SetPos(n);
    END ScrollBy;

    PROCEDURE MouseToPos(x,y: Longint): Longint;
    BEGIN
      IF kind = sbHorizontal THEN
        RETURN min + (x-in.left) * (max-min) DIV U.Max(in.right-in.left,1)
      ELSE
        RETURN min + (y-in.top)  * (max-min) DIV U.Max(in.bottom-in.top,1);
      END;
    END MouseToPos;

    PROCEDURE DoUpdatePosOnDrag(x,y: Longint);
    VAR
      n: Longint;
    BEGIN
      n:= MouseToPos(x-dragoffset,y-dragoffset);
      n:= U.Max(n,min);
      n:= U.Min(n,max-pagesize);
      SetPos(n);
    END DoUpdatePosOnDrag;

    PROCEDURE GetPxAtScroll(pos: Longint): Longint;
    VAR
      n,len: Longint;
    BEGIN
      IF kind = sbHorizontal THEN
        n   := in.left;
        len := in.right-in.left
      ELSE
        n   := in.top;
        len := in.bottom-in.top;
      END;
      RETURN n + (pos-min) * len DIV (max-min);
    END GetPxAtScroll;

    PROCEDURE DoUpdateCornerRect;
    BEGIN
      incorner := U.Rect(0, 0, 0, 0);
      IF kind = sbHorizontal THEN
        IF indentcorner > 0 THEN
          incorner:= U.Rect(width-indentcorner,0,width,height);
          DEC(in.right,indentcorner);
        ELSIF indentcorner < 0 THEN
          incorner:= U.Rect(0,0,ABS(indentcorner),height);
          INC(in.left,ABS(indentcorner));
        END;
      ELSE
        IF indentcorner > 0 THEN
          incorner:= U.Rect(0,height-indentcorner,width,height);
          DEC(in.bottom, indentcorner);
        ELSIF indentcorner < 0 THEN
          incorner:= U.Rect(0,0,width,ABS(indentcorner));
          INC(in.top,ABS(indentcorner));
        END;
      END;
    END DoUpdateCornerRect;

    PROCEDURE DoUpdateThumbRect;
    CONST
      cMinView = 16;
    VAR
      rect: W.Rect;
      cor : Longint;
    BEGIN
      inthumb    := U.Rect(0, 0, 0, 0);
      inpageup   := U.Rect(0, 0, 0, 0);
      inpagedown := U.Rect(0, 0, 0, 0);
      IF (max > min) & (pagesize < max) THEN
        IF ABS(page-(GetPxAtScroll(position + pagesize)-GetPxAtScroll(position))) > 4 THEN
          page := GetPxAtScroll(position + pagesize)-GetPxAtScroll(position);
        END;

        IF kind = sbHorizontal THEN
          IF in.right - in.left < cMinView THEN RETURN END;
          rect.top    := in.top;
          rect.bottom := in.bottom;
          rect.left   := GetPxAtScroll(position);
          rect.left   := U.Min(rect.left,in.right - cMinView);
          (*rect.right  := GetPxAtScroll(position + pagesize);*)
          rect.right  := rect.left + page;
          rect.right  := U.Max(rect.right,rect.left + cMinView);
          rect.right  := U.Min(rect.right,in.right);
        ELSE
          IF in.bottom - in.top < cMinView THEN RETURN END;
          rect.left   := in.left;
          rect.right  := in.right;
          rect.top    := GetPxAtScroll(position);
          rect.top    := U.Min(rect.top,in.bottom - cMinView);
          (*rect.bottom := GetPxAtScroll(position + pagesize);*)
          rect.bottom := rect.top + page;
          rect.bottom := U.Max(rect.bottom, rect.top + cMinView);
          rect.bottom := U.Min(rect.bottom,in.bottom);
        END;
        inthumb := rect;
      END;
      IF kind = sbHorizontal THEN
        inpageup   := U.Rect(in.left,in.top,inthumb.left,in.bottom);
        inpagedown := U.Rect(inthumb.right,in.top,in.right,in.bottom);
      ELSE
        inpageup   := U.Rect(in.left,in.top,in.right,inthumb.top);
        inpagedown := U.Rect(in.left,inthumb.bottom,in.right,in.bottom);
      END;

    END DoUpdateThumbRect;

    PROCEDURE DoPaintThumb;
    BEGIN
      IF ~ U.IsRectEmpty(inthumb) THEN
        canvas.Roundrect(inthumb.left,inthumb.top,inthumb.right,inthumb.bottom,thumbradius,colorfor.thumb.frame.color,colorfor.thumb.color);
        DrawPoints(inthumb,colorfor.thumb.frame.light);
      END;
    END DoPaintThumb;

    PROCEDURE DrawPoints(rect: W.Rect; c: Longint);
    VAR
      x,y,l,t: Longint;
    BEGIN
      t := rect.top + (rect.bottom - rect.top  - pointswidth) DIV 2 + 1;
      l := rect.left + (rect.right - rect.left - pointswidth) DIV 2 + 1;
      FOR y := t TO t + pointswidth-1 BY 3 DO
        FOR x := l TO l + pointswidth-1 BY 3 DO
          canvas.FillRect(x,y,x+2,y+2,c);
        END;
      END;
    END DrawPoints;

    PROCEDURE DrawArrow;
    VAR
      xc,yc,c: Longint;
    BEGIN
      IF kind = sbHorizontal THEN
        c := arupcolor;
        xc := (inup.right - inup.left) DIV 2 + 1;
        yc := (inup.bottom - inup.top) DIV 2;
        canvas.Line(xc,yc-4,xc,yc+4,    c);
        canvas.Line(xc-1,yc-3,xc-1,yc+3,c);
        canvas.Line(xc-2,yc-2,xc-2,yc+2,c);
        canvas.Line(xc-3,yc-1,xc-3,yc+1,c);
        c := ardowncolor;
        xc := indown.left + (indown.right - indown.left) DIV 2 - 1;
        yc := (indown.bottom - indown.top) DIV 2;
        canvas.Line(xc,yc-4,xc,yc+4,    c);
        canvas.Line(xc+1,yc-3,xc+1,yc+3,c);
        canvas.Line(xc+2,yc-2,xc+2,yc+2,c);
        canvas.Line(xc+3,yc-1,xc+3,yc+1,c);
      ELSE
        c := arupcolor;
        xc := (inup.right - inup.left) DIV 2;
        yc := (inup.bottom - inup.top) DIV 2 + 1;
        canvas.Line(xc-4,yc,xc+4,yc,    c);
        canvas.Line(xc-3,yc-1,xc+3,yc-1,c);
        canvas.Line(xc-2,yc-2,xc+2,yc-2,c);
        canvas.Line(xc-1,yc-3,xc+1,yc-3,c);
        c := ardowncolor;
        xc := (indown.right - indown.left) DIV 2;
        yc := indown.top + (indown.bottom - indown.top) DIV 2 - 1;
        canvas.Line(xc-4,yc,xc+4,yc,    c);
        canvas.Line(xc-3,yc+1,xc+3,yc+1,c);
        canvas.Line(xc-2,yc+2,xc+2,yc+2,c);
        canvas.Line(xc-1,yc+3,xc+1,yc+3,c);
      END;
    END DrawArrow;

    PROCEDURE WMSize*(VAR message: Cl.Message);
    BEGIN
      WMSize^(message);
      IF page # -1 THEN
        page := GetPxAtScroll(position + pagesize) - GetPxAtScroll(position);
      END;
    END WMSize;

    PROCEDURE Paint*;
    VAR
      size,shift1,shift2: Longint;
    BEGIN
      in := U.Rect(0,0,width,height);
      DoUpdateCornerRect;
      IF ~ U.IsRectEmpty(incorner) THEN
        canvas.FillRect(incorner.left,incorner.top,incorner.right,incorner.bottom,colorfor.thumb.color);
        DrawPoints(incorner,colorfor.thumb.frame.light);
      END;

      IF kind = sbHorizontal THEN
        size  := U.Min(in.bottom-in.top,(in.right-in.left) DIV 2);
        inup  := U.Rect(in.left,in.top,in.left+size,in.bottom);
        indown:= U.Rect(in.right-size,in.top,in.right,in.bottom);
        DrawArrow;
        INC(in.left,size);
        DEC(in.right,size);
      ELSE
        size  := U.Min(in.right-in.left,(in.bottom-in.top) DIV 2);
        inup  := U.Rect(in.left,in.top,in.right,in.top+size);
        indown:= U.Rect(in.left,in.bottom-size,in.right,in.bottom);
        DrawArrow;
        INC(in.top,size);
        DEC(in.bottom,size);
      END;

      DoUpdateThumbRect;

      shift1 := 0;
      shift2 := 0;
      IF downonpageup THEN
        IF kind = sbHorizontal THEN
          shift1 := thumbradius;
        ELSE
          shift2  := thumbradius;
        END;
        canvas.FillRect(inpageup.left,inpageup.top,inpageup.right+shift1,inpageup.bottom+shift2,colorfor.page.color);
      END;
      IF downonpagedown THEN
        IF kind = sbHorizontal THEN
          shift1 := thumbradius;
        ELSE
          shift2  := thumbradius;
        END;
        canvas.FillRect(inpagedown.left-shift1,inpagedown.top-shift2,inpagedown.right,inpagedown.bottom,colorfor.page.color);
      END;

      DoPaintThumb;

    END Paint;

  END Scrollbar;

  TabNotifyEvent*  = PROCEDURE {DELEGATE} (Sender: Tab);

  Tab* = OBJECT
  VAR
    name*    : Name;
    control* : C.Control;
    active   : Boolean;
    rect     : W.Rect;
    csrect   : W.Rect;
    cscolor  : Longint;
    csactive : Boolean;
    csdown   : Boolean;
  END Tab;

  Tabcontrol* = OBJECT (C.Customcontrol)
  VAR
    tabwidth*     : Longint;
    tabradius*    : Longint;
    tabangle*     : Longint;
    offset*       : Longint;
    count*        : Longint;
    tabs*         : Cl.List;
    activetab     : Tab;
    start         : Longint;
    end           : Longint;

    udwidth       : Longint;
    udrect        : W.Rect;

    tabcolor*     : Longint;
    tabframe*     : Longint;
    tableave*     : Longint;
    tabenter*     : Longint;
    tabdown*      : Longint;
    tabfrenter*   : Longint;
    activeframe*  : Longint;
    activecolor*  : Longint;

    textcolor*    : Longint;
    activetext*   : Longint;

    tbcolor       : Longint;
    tbframe       : Longint;
    tabindex      : Longint;

    updowncolor*  : Longint;
    updownframe*  : Longint;
    updownenter*  : Longint;
    updowndown*   : Longint;
    udleftactive  : Boolean;
    udrightactive : Boolean;
    udcolor       : Longint;
    udframe       : Longint;

    cswidth       : Longint;
    closecolor*   : Longint;
    closeenter*   : Longint;

    OnTabClose*   : TabNotifyEvent;
    OnTabDown*    : TabNotifyEvent;
    OnTabActivate*: TabNotifyEvent;

    PROCEDURE & Create*(Parent: C.Control);
    BEGIN
      Create^(Parent);
      classname    := "Tabcontrol";
      caption      := "";
      width        := 250;
      height       := 27;

      count        := 0;

      tabwidth     := 105;
      tabradius    := 5;
      tabangle     := 4;
      tabindex     := -1;
      offset       := 10;
      activetab    := NIL;
      start        := 0;
      end          := 0;

      tabcolor     := 0E8E8E8H;
      tabframe     := 0AAAAAAH;
      tableave     := 0E8E8E8H;
      tabenter     := 0D2D2D2H;
      tabfrenter   := G.clMedGray;
      tabdown      := 0DDDDDDH;
      activeframe  := G.clGray;
      activecolor  := G.clWhite;

      textcolor    := tabfrenter;
      activetext   := activeframe;

      tbcolor      := tabcolor;
      tbframe      := tabframe;

      updowncolor  := tabcolor;
      updownframe  := tabframe;
      updownenter  := tabenter;
      updowndown   := tabdown;
      udcolor      := updowncolor;
      udframe      := updownframe;
      udleftactive := FALSE;
      udrightactive:= FALSE;
      udwidth      := 18;

      cswidth      := 10;
      closecolor   := G.clSilver;
      closeenter   := G.clGray;
    END Create;

    PROCEDURE Destroy*;
    VAR
      i: Longint;
    BEGIN
      activetab := NIL;
      IF tabs # NIL THEN
        i := 0;
        WHILE i <= tabs.count-1 DO
          IF tabs.list[i](Tab).control # NIL THEN
            tabs.list[i](Tab).control.Destroy;
          END;
          INC(i);
        END;
        tabs.Clear;
        tabs := NIL;
      END;
      Destroy^;
    END Destroy;

    PROCEDURE SetActive(tab: Tab);
    BEGIN
      IF activetab # NIL THEN
        activetab.active := FALSE;
      END;
      tab.active := TRUE;
      activetab := tab;
      IF OnTabActivate # NIL THEN OnTabActivate(activetab) END;
    END SetActive;

    PROCEDURE AddTab*(name: String; control: C.Control);
    VAR
      tab: Tab;
    BEGIN
      IF tabs = NIL THEN NEW(tabs,0) END;
      NEW(tab);
      COPY(name,tab.name);
      tab.control  := control;
      tab.cscolor  := closecolor;
      tab.csactive := FALSE;
      SetActive(tab);
      tabs.Add(tab);
      INC(count);
      end := (width - (offset+5)*2 - tabwidth - udwidth*2 - offset +5) DIV tabwidth + start;
      IF (end < tabs.count-1) THEN
        INC(start,tabs.count-1-end);
      END;
      W.InvalidateRect(handle,NIL,W.False);
    END AddTab;

    PROCEDURE WMMouseUp*(VAR message: Cl.Message);
    VAR
      x,y,i: Longint;
    BEGIN
      WMMouseUp^(message);
      x := U.LoWord(message.lparam);
      y := U.HiWord(message.lparam);

      IF (tabs # NIL) & (tabs.count > 0) THEN
        FOR i := start TO end DO
          tabs.list[i](Tab).cscolor := closecolor;
        END;
      END;

      IF (tabs # NIL) & (tabs.count > 0) & (tabindex >= start) & (tabindex <= end)THEN
        IF tabs.list[tabindex](Tab).csactive & tabs.list[tabindex](Tab).csdown THEN

          IF (tabindex < tabs.count - 1) THEN
            IF start = 0 THEN
              tabs.list[tabindex+1](Tab).csrect := tabs.list[tabindex](Tab).csrect;
              tabs.list[tabindex+1](Tab).csactive := TRUE;
              tabs.list[tabindex+1](Tab).csdown := FALSE;
              tabs.list[tabindex+1](Tab).cscolor := closeenter;
            ELSE
              tabs.list[tabindex-1](Tab).csrect := tabs.list[tabindex](Tab).csrect;
              tabs.list[tabindex-1](Tab).csactive := TRUE;
              tabs.list[tabindex-1](Tab).csdown := FALSE;
              tabs.list[tabindex-1](Tab).cscolor := closeenter;
            END;
          END;

          IF tabs.list[tabindex](Tab).active THEN
            IF tabindex = tabs.count - 1 THEN
              IF tabindex > start THEN
                SetActive(tabs.list[tabindex-1](Tab));
              END;
            ELSIF start > 0 THEN
              SetActive(tabs.list[tabindex-1](Tab));
            ELSE
              SetActive(tabs.list[tabindex+1](Tab));
            END;
          END;

          IF OnTabClose # NIL THEN OnTabClose(tabs.list[tabindex](Tab)) END;

          IF tabs.list[tabindex](Tab).control # NIL THEN
            tabs.list[tabindex](Tab).control.Destroy;
            (*Cl.ClassList.Delete(tabs.list[tabindex](Tab).control.classname);*)
            W.DestroyWindow(tabs.list[tabindex](Tab).control.handle);
          END;
          tabs.Remove(tabs.list[tabindex](Tab));

          IF start > 0 THEN
            DEC(start);
          END;

          DEC(end);
          DEC(count);
          W.InvalidateRect(handle,NIL,W.False);
        END;
      END;

    END WMMouseUp;

    PROCEDURE WMMouseDown*(VAR message: Cl.Message);
    BEGIN
      WMMouseDown^(message);
      IF udleftactive OR udrightactive THEN
        udcolor := updowndown;
        IF udleftactive THEN
          start := start + 1;
        ELSIF udrightactive THEN
          start := start - 1;
          IF start < 0 THEN start := 0; END;
        END;
        W.InvalidateRect(handle,NIL,W.False);
      ELSIF (tabs # NIL) & (tabs.count > 0) & (tabindex >= start) & (tabindex <= end)THEN
        IF tabs.list[tabindex](Tab).csactive THEN
           tabs.list[tabindex](Tab).csdown := TRUE;
        ELSE
          SetActive(tabs.list[tabindex](Tab));
          IF OnTabDown # NIL THEN OnTabDown(tabs.list[tabindex](Tab)) END;
          W.InvalidateRect(handle,tabs.list[tabindex](Tab).rect,W.False);
          tabs.list[tabindex](Tab).csdown := FALSE;
        END;
      END;
    END WMMouseDown;

    PROCEDURE WMMouseMove*(VAR message: Cl.Message);
    VAR
      x,y,i : Longint;
      rect  : W.Rect;
      index : Longint;
    BEGIN
      WMMouseMove^(message);
      x := U.LoWord(message.lparam);
      y := U.HiWord(message.lparam);
      udleftactive := FALSE;
      udrightactive:= FALSE;
      IF U.XYInRect(x,y,udrect) THEN
        udcolor      := updownenter;
        rect := udrect;
        DEC(rect.right,(rect.right - rect.left) DIV 2);
        IF U.XYInRect(x,y,rect) THEN
          udleftactive := TRUE;
        ELSE
          udrightactive:= TRUE;
        END;
        tbcolor := tabcolor;
        tbframe := tabframe;
      END;
      W.InvalidateRect(handle,udrect,W.False);

      IF (tabs # NIL) & (tabs.count > 0) THEN
        index    := tabindex;
        tabindex := (x-(offset+5)) DIV tabwidth + start;

        IF (tabindex >= start) & (tabindex <= end)THEN
          IF ~ mousedown THEN
            tabs.list[tabindex](Tab).cscolor  := closecolor;
          END;
          IF U.XYInRect(x,y,tabs.list[tabindex](Tab).csrect) THEN
            IF ~ mousedown THEN
              tabs.list[tabindex](Tab).cscolor := closeenter;
            END;
            tabs.list[tabindex](Tab).csactive := TRUE;
          ELSE
            tabs.list[tabindex](Tab).csactive := FALSE;
          END;
        ELSE
          IF ~ mousedown THEN
            FOR i := start TO end DO
              tabs.list[i](Tab).cscolor := closecolor;
            END;
          END;
        END;

        IF (*(index # tabindex) &*) (tabindex >= start) & (tabindex <= end)THEN
          tbcolor := tabenter;
          tbframe := tabfrenter;
          IF ~ mousedown THEN
            FOR i := start TO end DO
              IF i # tabindex THEN
                tabs.list[i](Tab).cscolor := closecolor;
                W.InvalidateRect(handle,tabs.list[i](Tab).csrect,W.False);
              END;
            END;
          END;
          W.InvalidateRect(handle,tabs.list[tabindex](Tab).rect,W.False);
        ELSE
          W.InvalidateRect(handle,NIL,W.False);
        END;
      END;

    END WMMouseMove;

    PROCEDURE WMMouseLeave*;
    BEGIN
      WMMouseLeave^;
      IF (tabindex >= start) & (tabindex <= end)THEN
        tabs.list[tabindex](Tab).cscolor := closecolor;
      END;
      tabindex := -1;
      IF udleftactive OR udrightactive THEN
        udleftactive := FALSE;
        udrightactive:= FALSE;
        W.InvalidateRect(handle,udrect,W.False);
      END;
      W.InvalidateRect(handle,NIL,W.False);
    END WMMouseLeave;

    PROCEDURE FillPrizm(x1,y1,x2,y2,o,c1: Longint);
    VAR
      dx,dy,i,sx,sy,e,x,y,c:Longint;
      chk: Boolean;
    BEGIN

      dx := ABS(x1-x2);
      dy := ABS(y1-y2);
      sx := G.Sign(x2-x1);
      sy := G.Sign(y2-y1);
      x  := x1;
      y  := y1;
      chk:= FALSE;

      IF dy>dx THEN
        dx := dx+dy;
        dy := dx-dy;
        dx := dx-dy;
        chk:= TRUE;
      END;

      e:= 2 * dy - dx;

      FOR i:=0 TO dx DO
        canvas.Line(x+o,y,tabwidth+o-x+1,y,c1);
        IF e>=0 THEN
          IF chk THEN x:=x+sx ELSE y:=y+sy; END;
          e:=e-2*dx;
        END;
        IF chk THEN y:=y+sy ELSE x:=x+sx; END;
        e:=e+2*dy;
      END;

    END FillPrizm;

    PROCEDURE DrawClose(tab: Tab; c: Longint);
    VAR
      xc,yc,r: Longint;
    BEGIN
      r  := (tab.csrect.right - tab.csrect.left) DIV 2;
      xc := tab.csrect.left + r;
      yc := tab.csrect.top  + r;
      canvas.AntialiasCircle(xc,yc,r,tab.cscolor,tab.cscolor,TRUE);
      canvas.Line(xc-2,yc-2,xc+2,yc+2,c);
      canvas.Line(xc-2,yc+2,xc+2,yc-2,c);
    END DrawClose;

    PROCEDURE DrawTab(tab: Tab; c1,c2: Longint);
    BEGIN
      canvas.AntialiasCircle(tab.rect.left+tabradius+tabangle+1,tab.rect.top+tabradius,tabradius,c1,c2,TRUE);
      canvas.AntialiasCircle(tab.rect.right-tabradius-tabangle-1,tab.rect.top+tabradius,tabradius,c1,c2,TRUE);
      canvas.FillRect(tab.rect.left+tabradius+tabangle,tab.rect.top,tab.rect.right-tabradius-tabangle,tab.rect.top+tabradius,c2);
      canvas.Line(tab.rect.left+tabradius+tabangle,tab.rect.top,tab.rect.right-tabradius-tabangle,tab.rect.top,c1);
      FillPrizm(0-tabangle,tab.rect.bottom,tabangle,tab.rect.top+tabradius,tab.rect.left,c2);
      canvas.AntialiasLine(tab.rect.left-tabangle,tab.rect.bottom - 1,tab.rect.left+tabangle,tab.rect.top+tabradius,c1);
      canvas.AntialiasLine(tab.rect.right+tabangle,tab.rect.bottom - 1,tab.rect.right-tabangle,tab.rect.top+tabradius,c1);

      canvas.TextOut(tab.rect.left + tabangle + tabradius + 5,tab.rect.top + (tab.rect.bottom - tab.rect.top - canvas.font.height) DIV 2,tab.name);

      tab.csrect.left   := tab.rect.right - cswidth - tabangle - tabradius;
      tab.csrect.top    := tab.rect.top + (tab.rect.bottom - tab.rect.top - cswidth) DIV 2;
      tab.csrect.right  := tab.rect.right - tabangle - tabradius;
      tab.csrect.bottom := tab.csrect.top + cswidth;
      DrawClose(tab,c2);
    END DrawTab;

    PROCEDURE DrawUpDown(rect: W.Rect);
    VAR
      xc,yc,r,c1,c2: Longint;
    BEGIN
      IF rect.left >= 5 THEN
        c1 := activeframe;
        c2 := updowncolor;
        IF udleftactive THEN
          c2 := udcolor;
        END;

        r := (rect.right - rect.left) DIV 4;
        xc := rect.left + r;
        yc := rect.top  + r;
        canvas.AntialiasCircle(xc,yc,r,c1,c2,TRUE);
        canvas.FillRect(rect.left + r,rect.top,rect.left + r * 2 + 1,rect.bottom+1,c2);
        canvas.Line(rect.left + r,rect.top,rect.left + r * 2 + 1,rect.top,c1);
        canvas.Line(rect.left + r,rect.bottom,rect.left + r * 2 + 1,rect.bottom,c1);

        canvas.Line(xc,yc,xc+3,yc-3,c1);
        canvas.Line(xc,yc,xc+3,yc+3,c1);
        canvas.Line(xc-2,yc,xc+3-2,yc-3,c1);
        canvas.Line(xc-2,yc,xc+3-2,yc+3,c1);

        c1 := activeframe;
        c2 := updowncolor;
        IF udrightactive THEN
          c2 := udcolor;
        END;

        xc := rect.right - r;
        canvas.AntialiasCircle(xc,yc,r,c1,c2,TRUE);
        canvas.FillRect(rect.left + r * 2,rect.top,rect.right - r,rect.bottom+1,c2);
        canvas.Line(rect.left + r * 2,rect.top,rect.right - r,rect.top,c1);
        canvas.Line(rect.left + r * 2,rect.bottom,rect.right - r,rect.bottom,c1);

        canvas.Line(xc,yc,xc-3,yc-3,c1);
        canvas.Line(xc,yc,xc-3,yc+3,c1);
        canvas.Line(xc+2,yc,xc-3+2,yc-3,c1);
        canvas.Line(xc+2,yc,xc-3+2,yc+3,c1);

        canvas.Line(rect.left + r * 2,rect.top + 2,rect.left + r * 2,rect.bottom-1,c1);
      END;
    END DrawUpDown;

    PROCEDURE Paint*;
    VAR
      i,len  : Longint;
      updown : Boolean;
      acttab : Longint;
      fc,bc  : Longint;
    BEGIN
      IF (tabs # NIL) & (tabs.count > 0) THEN

        updown := FALSE;
        i := start;
        end := (width - (offset+5)*2 - tabwidth - udwidth*2 - offset + 5) DIV tabwidth + i;
        len := end - start;

        IF start + len > tabs.count-1 THEN
          DEC(start,start + len - (tabs.count - 1));
          IF start < 0 THEN start := 0 END;
          i := start;
        END;

        IF end > tabs.count-1 THEN
          end := tabs.count-1;
        END;

        IF (i>0) OR (end < tabs.count-1) THEN updown := TRUE END;

        acttab := -1;
        WHILE i <= end DO
          tabs.list[i](Tab).rect.left   := offset + 5 + (i-start)*tabwidth;
          tabs.list[i](Tab).rect.top    := 2;
          tabs.list[i](Tab).rect.right  := tabs.list[i](Tab).rect.left+tabwidth;
          tabs.list[i](Tab).rect.bottom := height - 1;
          IF ~ tabs.list[i](Tab).active THEN
            fc := tabframe;
            bc := tableave;
            IF i = tabindex THEN
              fc := tbframe;
              bc := tbcolor;
            END;
            canvas.font.color := textcolor;
            DrawTab(tabs.list[i](Tab),fc,bc);
          ELSE
            acttab := i;
          END;
          INC(i);
        END;
        IF acttab # -1 THEN
          canvas.font.color := activetext;
          DrawTab(tabs.list[acttab](Tab),activeframe,activecolor);
          canvas.Line(offset - 5,tabs.list[acttab](Tab).rect.bottom,tabs.list[acttab](Tab).rect.left - tabangle,tabs.list[acttab](Tab).rect.bottom,activeframe);
          canvas.Line(tabs.list[acttab](Tab).rect.right + tabangle + 1,tabs.list[acttab](Tab).rect.bottom,width - offset + 5,tabs.list[acttab](Tab).rect.bottom,activeframe);
        ELSE
          IF width > offset THEN
            canvas.Line(offset - 5,height - 1,width - offset + 5,height - 1,activeframe);
          END;
        END;

        IF updown THEN
          udrect.left   := width - offset + 5 - udwidth*2;
          udrect.top    := (height - udwidth) DIV 2;
          udrect.right  := width - offset + 5;
          udrect.bottom := (height + udwidth) DIV 2;
          DrawUpDown(udrect);
        END;

      ELSE
        (*canvas.Line(offset - 5,height - 1,width - offset + 5,height - 1,activeframe);*)
      END;
    END Paint;

  END Tabcontrol;

END Stdctrls.

