MODULE Windows;

IMPORT
  SYSTEM, Kernel, Kernel32;

TYPE
  Byte*      = SYSTEM.BYTE;
  Char*      = CHAR;
  Boolean*   = BOOLEAN;
  Shortint*  = SHORTINT;
  Integer*   = INTEGER;
  Longint*   = LONGINT;
  Real*      = REAL;
  Longreal*  = LONGREAL;
  Set*	     = SET;
  Pointer*   = SYSTEM.PTR;
  String*    = ARRAY OF CHAR;
  Name*      = ARRAY 64 OF CHAR;

CONST
  NULL*                    = 0;
  False*                   = NULL;
  True*                    = 1;

  BI_RGB*                  = 0;

  BS_PUSHBUTTON*           =  {};
  BS_DEFPUSHBUTTON*        =  {0};
  BS_CHECKBOX*             =  {1};
  BS_AUTOCHECKBOX*         =  {0, 1};
  BS_RADIOBUTTON*          =  {2};
  BS_3STATE*               =  {0, 2};
  BS_AUTO3STATE*           =  {1, 2};
  BS_GROUPBOX*             =  {0..2};
  BS_USERBUTTON*           =  {3};
  BS_AUTORADIOBUTTON*      =  {0, 3};
  BS_OWNERDRAW*            =  {0, 1, 3};
  BS_LEFTTEXT*             =  {5};
  BS_TEXT*                 =  {};
  BS_ICON*                 =  {6};
  BS_BITMAP*               =  {7};
  BS_LEFT*                 =  {8};
  BS_RIGHT*                =  {9};
  BS_CENTER*               =  {8, 9};
  BS_TOP*                  =  {10};
  BS_BOTTOM*               =  {11};
  BS_VCENTER*              =  {10, 11};
  BS_PUSHLIKE*             =  {12};
  BS_MULTILINE*            =  {13};
  BS_NOTIFY*               =  {14};
  BS_FLAT*                 =  {15};
  BS_RIGHTBUTTON*          =  {5};

  CC_RGBINIT*              = {0};
  CC_FULLOPEN*             = {1};
  CC_PREVENTFULLOPEN*      = {2};
  CC_SHOWHELP*             = {3};
  CC_ENABLEHOOK*           = {4};
  CC_ENABLETEMPLATE*       = {5};
  CC_ENABLETEMPLATEHANDLE* = {6};
  CC_SOLIDCOLOR*           = {7};
  CC_ANYCOLOR*             = {8};

  CF_SCREENFONTS*          = {0};
  CF_PRINTERFONTS*         = {1};
  CF_BOTH*                 = {0, 1};
  CF_SHOWHELP*             = {2};
  CF_ENABLEHOOK*           = {3};
  CF_ENABLETEMPLATE*       = {4};
  CF_ENABLETEMPLATEHANDLE* = {5};
  CF_INITTOLOGFONTSTRUCT*  = {6};
  CF_USESTYLE*             = {7};
  CF_EFFECTS*              = {8};
  CF_APPLY*                = {9};
  CF_ANSIONLY*             = {10};
  CF_SCRIPTSONLY*          = {10};
  CF_NOVECTORFONTS*        = {11};
  CF_NOOEMFONTS*           = {11};
  CF_NOSIMULATIONS*        = {12};
  CF_LIMITSIZE*            = {13};
  CF_FIXEDPITCHONLY*       = {14};
  CF_WYSIWYG*              = {15};
  CF_FORCEFONTEXIST*       = {16};
  CF_SCALABLEONLY*         = {17};
  CF_TTONLY*               = {18};
  CF_NOFACESEL*            = {19};
  CF_NOSTYLESEL*           = {20};
  CF_NOSIZESEL*            = {21};
  CF_SELECTSCRIPT*         = {22};
  CF_NOSCRIPTSEL*          = {23};
  CF_NOVERTFONTS*          = {24};

  CF_TEXT*                 = 1 (* {0} *);
  CF_BITMAP*               = 2 (* {1} *);
  CF_METAFILEPICT*         = 3 (* {0, 1} *);
  CF_SYLK*                 = 4 (* {2} *);
  CF_DIF*                  = 5 (* {0, 2} *);
  CF_TIFF*                 = 6 (* {1, 2} *);
  CF_OEMTEXT*              = 7 (* {0..2} *);
  CF_DIB*                  = 8 (* {3} *);
  CF_PALETTE*              = 9 (* {0, 3} *);
  CF_PENDATA*              = 10 (* {1, 3} *);
  CF_RIFF*                 = 11 (* {0, 1, 3} *);
  CF_WAVE*                 = 12 (* {2, 3} *);
  CF_UNICODETEXT*          = 13 (* {0, 2, 3} *);
  CF_ENHMETAFILE*          = 14 (* {1..3} *);
  CF_HDROP*                = 15 (* {0..3} *);
  CF_LOCALE*               = 16 (* {4} *);
  CF_MAX*                  = 17 (* {0, 4} *);
  CF_OWNERDISPLAY*         = 128 (* {7} *);
  CF_DSPTEXT*              = 129 (* {0, 7} *);
  CF_DSPBITMAP*            = 130 (* {1, 7} *);
  CF_DSPMETAFILEPICT*      = 131 (* {0, 1, 7} *);
  CF_DSPENHMETAFILE*       = 142 (* {1..3, 7} *);
  CF_PRIVATEFIRST*         = 512 (* {9} *);
  CF_PRIVATELAST*          = 767 (* {0..7, 9} *);
  CF_GDIOBJFIRST*          = 768 (* {8, 9} *);
  CF_GDIOBJLAST*           = 1023 (* {0..9} *);

  COLOR_SCROLLBAR*         = 0;
  COLOR_BACKGROUND*        = 1;
  COLOR_ACTIVECAPTION*     = 2;
  COLOR_INACTIVECAPTION*   = 3;
  COLOR_MENU*              = 4;
  COLOR_WINDOW*            = 5;
  COLOR_WINDOWFRAME*       = 6;
  COLOR_MENUTEXT*          = 7;
  COLOR_WINDOWTEXT*        = 8;
  COLOR_CAPTIONTEXT*       = 9;
  COLOR_ACTIVEBORDER*      = 10;
  COLOR_INACTIVEBORDER*    = 11;
  COLOR_APPWORKSPACE*      = 12;
  COLOR_HIGHLIGHT*         = 13;
  COLOR_HIGHLIGHTTEXT*     = 14;
  COLOR_BTNFACE*           = 15;
  COLOR_BTNSHADOW*         = 16;
  COLOR_GRAYTEXT*          = 17;
  COLOR_BTNTEXT*           = 18;
  COLOR_INACTIVECAPTIONTEXT* = 19 ;
  COLOR_BTNHIGHLIGHT*      = 20;
  COLOR_3DDKSHADOW*        = 21;
  COLOR_3DLIGHT*           = 22;
  COLOR_INFOTEXT*          = 23;
  COLOR_INFOBK*            = 24;
  COLOR_DESKTOP*           = 1;
  COLOR_3DFACE*            = 15;
  COLOR_3DSHADOW*          = 16;
  COLOR_3DHIGHLIGHT*       = 20;
  COLOR_3DHILIGHT*         = 20;
  COLOR_BTNHILIGHT*        = 20;

  CS_VREDRAW*              = {0};
  CS_HREDRAW*              = {1};
  CS_KEYCVTWINDOW*         = {2};
  CS_DBLCLKS*              = {3};
  CS_OWNDC*                = {5};
  CS_CLASSDC*              = {6};
  CS_PARENTDC*             = {7};
  CS_NOKEYCVT*             = {8};
  CS_NOCLOSE*              = {9};
  CS_SAVEBITS*             = {11};
  CS_BYTEALIGNCLIENT*      = {12};
  CS_BYTEALIGNWINDOW*      = {13};
  CS_GLOBALCLASS*          = {14};
  CS_IME*                  = {16};
  CS_DROPSHADOW*           = {17};

  DIB_RGB_COLORS*          = 0;
  DEFAULT_GUI_FONT*        = 17;

  DLGC_WANTARROWS*         = {0};
  DLGC_WANTTAB*            = {1};
  DLGC_WANTALLKEYS*        = {2};
  DLGC_WANTMESSAGE*        = {2};
  DLGC_HASSETSEL*          = {3};
  DLGC_DEFPUSHBUTTON*      = {4};
  DLGC_UNDEFPUSHBUTTON*    = {5};
  DLGC_RADIOBUTTON*        = {6};
  DLGC_WANTCHARS*          = {7};
  DLGC_STATIC*             = {8};
  DLGC_BUTTON*             = {13};

  ETO_OPAQUE*              = {1};
  ETO_CLIPPED*             = {2};
  ETO_GLYPH_INDEX*         = {4};
  ETO_RTLREADING*          = {7};

  FW_DONTCARE*             = 0;
  FW_THIN*                 = 100;
  FW_EXTRALIGHT*           = 200;
  FW_LIGHT*                = 300;
  FW_NORMAL*               = 400;
  FW_MEDIUM*               = 500;
  FW_SEMIBOLD*             = 600;
  FW_BOLD*                 = 700;
  FW_EXTRABOLD*            = 800;
  FW_HEAVY*                = 900;
  FW_ULTRALIGHT*           = 200;
  FW_REGULAR*              = 400;
  FW_DEMIBOLD*             = 600;
  FW_ULTRABOLD*            = 800;
  FW_BLACK*                = 900;

  GCL_MENUNAME*            = -8;
  GCL_HBRBACKGROUND*       = -10;
  GCL_HCURSOR*             = -12;
  GCL_HICON*               = -14;
  GCL_HMODULE*             = -16;
  GCL_CBWNDEXTRA*          = -18;
  GCL_CBCLSEXTRA*          = -20;
  GCL_WNDPROC*             = -24;
  GCL_STYLE*               = -26;
  GCW_ATOM*                = -32;
  GCL_HICONSM*             = -34;

  GMEM_FIXED*              = {};
  GMEM_MOVEABLE*           = {1};
  GMEM_NOCOMPACT*          = {4};
  GMEM_NODISCARD*          = {5};
  GMEM_ZEROINIT*           = {6};
  GMEM_MODIFY*             = {7};
  GMEM_DISCARDABLE*        = {8};
  GMEM_NOT_BANKED*         = {12};
  GMEM_SHARE*              = {13};
  GMEM_DDESHARE*           = {13};
  GMEM_NOTIFY*             = {14};
  GMEM_LOWER*              = {12};
  GMEM_VALID_FLAGS*        = {1, 4..6, 8..14};
  GMEM_INVALID_HANDLE*     = {15};
  GHND*                    = {1, 6};
  GPTR*                    = {6};
  GMEM_DISCARDED*          = {14};
  GMEM_LOCKCOUNT*          = {0..7};

  HEAP_NO_SERIALIZE*          = {0};
  HEAP_GROWABLE*              = {1};
  HEAP_GENERATE_EXCEPTIONS*   = {2};
  HEAP_ZERO_MEMORY*           = {3};
  HEAP_REALLOC_IN_PLACE_ONLY* = {4};
  HEAP_TAIL_CHECKING_ENABLED* = {5};
  HEAP_FREE_CHECKING_ENABLED* = {6};
  HEAP_DISABLE_COALESCE_ON_FREE* = {7};
  HEAP_CREATE_ALIGN_16*       = {16};
  HEAP_CREATE_ENABLE_TRACING* = {17};
  HEAP_MAXIMUM_TAG*           = {0..11};
  HEAP_PSEUDO_TAG_FLAG*       = {15};
  HEAP_TAG_SHIFT*             = {4};

  GWL_WNDPROC*             = -4;
  GWL_HINSTANCE*           = -6;
  GWL_HWNDPARENT*          = -8;
  GWL_STYLE*               = -16;
  GWL_EXSTYLE*             = -20;
  GWL_USERDATA*            = -21;
  GWL_ID*                  = -12;

  HWND_TOP*                = 0;
  HWND_BOTTOM*             = 1;
  HWND_TOPMOST*            = -1;
  HWND_NOTOPMOST*          = -2;

  IDOK*                    = 1;
  IDCANCEL*                = 2;
  IDABORT*                 = 3;
  IDRETRY*                 = 4;
  IDIGNORE*                = 5;
  IDYES*                   = 6;
  IDNO*                    = 7;
  IDCLOSE*                 = 8;
  IDHELP*                  = 9;

  IDC_ARROW*               = 32512;
  IDC_IBEAM*               = 32513;
  IDC_WAIT*                = 32514;
  IDC_CROSS*               = 32515;
  IDC_UPARROW*             = 32516;
  IDC_SIZE*                = 32640;
  IDC_ICON*                = 32641;
  IDC_SIZENWSE*            = 32642;
  IDC_SIZENESW*            = 32643;
  IDC_SIZEWE*              = 32644;
  IDC_SIZENS*              = 32645;
  IDC_SIZEALL*             = 32646;
  IDC_NO*                  = 32648;
  IDC_APPSTARTING*         = 32650;
  IDC_HELP*                = 32651;

  IMAGE_BITMAP*            = 0;
  IMAGE_ICON*              = 1;
  IMAGE_CURSOR*            = 2;
  LR_LOADFROMFILE*         = {4};

  MB_OK*                   = {};
  MB_OKCANCEL*             = {0};
  MB_ABORTRETRYIGNORE*     = {1};
  MB_YESNOCANCEL*          = {0, 1};
  MB_YESNO*                = {2};
  MB_RETRYCANCEL*          = {0, 2};
  MB_ICONHAND*             = {4};
  MB_ICONQUESTION*         = {5};
  MB_ICONEXCLAMATION*      = {4, 5};
  MB_ICONASTERISK*         = {6};
  MB_USERICON*             = {7};
  MB_ICONWARNING*          = {4, 5};
  MB_ICONERROR*            = {4};
  MB_ICONINFORMATION*      = {6};
  MB_ICONSTOP*             = {4};
  MB_DEFBUTTON1*           = {};
  MB_DEFBUTTON2*           = {8};
  MB_DEFBUTTON3*           = {9};
  MB_DEFBUTTON4*           = {8, 9};
  MB_APPLMODAL*            = {};
  MB_SYSTEMMODAL*          = {12};
  MB_TASKMODAL*            = {13};
  MB_HELP*                 = {14};
  MB_NOFOCUS*              = {15};
  MB_SETFOREGROUND*        = {16};
  MB_DEFAULT_DESKTOP_ONLY* = {17};
  MB_TOPMOST*              = {18};
  MB_RIGHT*                = {19};
  MB_RTLREADING*           = {20};
  MB_SERVICE_NOTIFICATION* = {21};
  MB_TYPEMASK*             = {0..3};
  MB_ICONMASK*             = {4..7};
  MB_DEFMASK*              = {8..11};
  MB_MODEMASK*             = {12, 13};
  MB_MISCMASK*             = {14, 15};

  FN_READONLY*             = {0};
  OFN_OVERWRITEPROMPT*     = {1};
  OFN_HIDEREADONLY*        = {2};
  OFN_NOCHANGEDIR*         = {3};
  OFN_SHOWHELP*            = {4};
  OFN_ENABLEHOOK*          = {5};
  OFN_ENABLETEMPLATE*      = {6};
  OFN_ENABLETEMPLATEHANDLE* = {7};
  OFN_NOVALIDATE*         = {8};
  OFN_ALLOWMULTISELECT*   = {9};
  OFN_EXTENSIONDIFFERENT* = {10};
  OFN_PATHMUSTEXIST*      = {11};
  OFN_FILEMUSTEXIST*      = {12};
  OFN_CREATEPROMPT*       = {13};
  OFN_SHAREAWARE*         = {14};
  OFN_NOREADONLYRETURN*   = {15};
  OFN_NOTESTFILECREATE*   = {16};
  OFN_NONETWORKBUTTON*    = {17};
  OFN_NOLONGNAMES*        = {18};
  OFN_EXPLORER*           = {19};
  OFN_NODEREFERENCELINKS* = {20};
  OFN_LONGNAMES*          = {21};
  OFN_SHAREFALLTHROUGH*   = 2;
  OFN_SHARENOWARN*        = 1;
  OFN_SHAREWARN*          = 0;

  PS_SOLID*                = 0;
  PS_DASH*                 = 1;
  PS_DOT*                  = 2;
  PS_DASHDOT*              = 3;
  PS_DASHDOTDOT*           = 4;
  PS_NULL*                 = 5;
  PS_INSIDEFRAME*          = 6;
  PS_USERSTYLE*            = 7;
  PS_ALTERNATE*            = 8;
  PS_STYLE_MASK*           = 15;
  PS_ENDCAP_ROUND*         = 0;
  PS_ENDCAP_SQUARE*        = 256;
  PS_ENDCAP_FLAT*          = 512;
  PS_ENDCAP_MASK*          = 3840;
  PS_JOIN_ROUND*           = 0;
  PS_JOIN_BEVEL*           = 4096;
  PS_JOIN_MITER*           = 8192;
  PS_JOIN_MASK*            = 61440;
  PS_COSMETIC*             = 0;
  PS_GEOMETRIC*            = 65536;
  PS_TYPE_MASK*            = 983040;

  RGN_AND*                 = 1;
  RGN_OR*                  = 2;
  RGN_XOR*                 = 3;
  RGN_DIFF*                = 4;
  RGN_COPY*                = 5;

  SPI_GETWORKAREA*         = 48;

  SWP_NOSIZE*              = {0};
  SWP_NOMOVE*              = {1};
  SWP_NOZORDER*            = {2};
  SWP_NOREDRAW*            = {3};
  SWP_NOACTIVATE*          = {4};
  SWP_FRAMECHANGED*        = {5};
  SWP_SHOWWINDOW*          = {6};
  SWP_HIDEWINDOW*          = {7};

  SRCCOPY*                 = 13369376;
  SRCPAINT*                = 15597702;
  SRCAND*                  = 8913094;
  SRCINVERT*               = 6684742;
  SRCERASE*                = 4457256;
  NOTSRCCOPY*              = 3342344;
  NOTSRCERASE*             = 1114278;
  MERGECOPY*               = 12583114;
  MERGEPAINT*              = 12255782;
  PATCOPY*                 = 15728673;
  PATPAINT*                = 16452105;
  PATINVERT*               = 5898313;
  DSTINVERT*               = 5570569;
  BLACKNESS*               = 66;
  WHITENESS*               = 16711778;

  SW_HIDE*                 = 0;
  SW_SHOWNORMAL*           = 1;
  SW_NORMAL*               = 1;
  SW_SHOWMINIMIZED*        = 2;
  SW_SHOWMAXIMIZED*        = 3;
  SW_MAXIMIZE*             = 3;
  SW_SHOWNOACTIVATE*       = 4;
  SW_SHOW*                 = 5;
  SW_MINIMIZE*             = 6;
  SW_SHOWMINNOACTIVE*      = 7;
  SW_SHOWNA*               = 8;
  SW_RESTORE*              = 9;
  SW_SHOWDEFAULT*          = 10;
  SW_MAX*                  = 10;

  VK_LBUTTON*              = 1 (* {0} *);
  VK_RBUTTON*              = 2 (* {1} *);
  VK_CANCEL*               = 3 (* {0, 1} *);
  VK_MBUTTON*              = 4 (* {2} *);
  VK_BACK*                 = 8 (* {3} *);
  VK_TAB*                  = 9 (* {0, 3} *);
  VK_CLEAR*                = 12 (* {2, 3} *);
  VK_RETURN*               = 13 (* {0, 2, 3} *);
  VK_SHIFT*                = 16 (* {4} *);
  VK_CONTROL*              = 17 (* {0, 4} *);
  VK_MENU*                 = 18 (* {1, 4} *);
  VK_PAUSE*                = 19 (* {0, 1, 4} *);
  VK_CAPITAL*              = 20 (* {2, 4} *);
  VK_ESCAPE*               = 27 (* {0, 1, 3, 4} *);
  VK_SPACE*                = 32 (* {5} *);
  VK_PRIOR*                = 33 (* {0, 5} *);
  VK_NEXT*                 = 34 (* {1, 5} *);
  VK_END*                  = 35 (* {0, 1, 5} *);
  VK_HOME*                 = 36 (* {2, 5} *);
  VK_LEFT*                 = 37 (* {0, 2, 5} *);
  VK_UP*                   = 38 (* {1, 2, 5} *);
  VK_RIGHT*                = 39 (* {0..2, 5} *);
  VK_DOWN*                 = 40 (* {3, 5} *);
  VK_SELECT*               = 41 (* {0, 3, 5} *);
  VK_PRINT*                = 42 (* {1, 3, 5} *);
  VK_EXECUTE*              = 43 (* {0, 1, 3, 5} *);
  VK_SNAPSHOT*             = 44 (* {2, 3, 5} *);
  VK_INSERT*               = 45 (* {0, 2, 3, 5} *);
  VK_DELETE*               = 46 (* {1..3, 5} *);
  VK_HELP*                 = 47 (* {0..3, 5} *);
  VK_LWIN*                 = 91 (* {0, 1, 3, 4, 6} *);
  VK_RWIN*                 = 92 (* {2..4, 6} *);
  VK_APPS*                 = 93 (* {0, 2..4, 6} *);
  VK_NUMPAD0*              = 96 (* {5, 6} *);
  VK_NUMPAD1*              = 97 (* {0, 5, 6} *);
  VK_NUMPAD2*              = 98 (* {1, 5, 6} *);
  VK_NUMPAD3*              = 99 (* {0, 1, 5, 6} *);
  VK_NUMPAD4*              = 100 (* {2, 5, 6} *);
  VK_NUMPAD5*              = 101 (* {0, 2, 5, 6} *);
  VK_NUMPAD6*              = 102 (* {1, 2, 5, 6} *);
  VK_NUMPAD7*              = 103 (* {0..2, 5, 6} *);
  VK_NUMPAD8*              = 104 (* {3, 5, 6} *);
  VK_NUMPAD9*              = 105 (* {0, 3, 5, 6} *);
  VK_MULTIPLY*             = 106 (* {1, 3, 5, 6} *);
  VK_ADD*                  = 107 (* {0, 1, 3, 5, 6} *);
  VK_SEPARATOR*            = 108 (* {2, 3, 5, 6} *);
  VK_SUBTRACT*             = 109 (* {0, 2, 3, 5, 6} *);
  VK_DECIMAL*              = 110 (* {1..3, 5, 6} *);
  VK_DIVIDE*               = 111 (* {0..3, 5, 6} *);
  VK_F1*                   = 112 (* {4..6} *);
  VK_F2*                   = 113 (* {0, 4..6} *);
  VK_F3*                   = 114 (* {1, 4..6} *);
  VK_F4*                   = 115 (* {0, 1, 4..6} *);
  VK_F5*                   = 116 (* {2, 4..6} *);
  VK_F6*                   = 117 (* {0, 2, 4..6} *);
  VK_F7*                   = 118 (* {1, 2, 4..6} *);
  VK_F8*                   = 119 (* {0..2, 4..6} *);
  VK_F9*                   = 120 (* {3..6} *);
  VK_F10*                  = 121 (* {0, 3..6} *);
  VK_F11*                  = 122 (* {1, 3..6} *);
  VK_F12*                  = 123 (* {0, 1, 3..6} *);
  VK_F13*                  = 124 (* {2..6} *);
  VK_F14*                  = 125 (* {0, 2..6} *);
  VK_F15*                  = 126 (* {1..6} *);
  VK_F16*                  = 127 (* {0..6} *);
  VK_F17*                  = 128 (* {7} *);
  VK_F18*                  = 129 (* {0, 7} *);
  VK_F19*                  = 130 (* {1, 7} *);
  VK_F20*                  = 131 (* {0, 1, 7} *);
  VK_F21*                  = 132 (* {2, 7} *);
  VK_F22*                  = 133 (* {0, 2, 7} *);
  VK_F23*                  = 134 (* {1, 2, 7} *);
  VK_F24*                  = 135 (* {0..2, 7} *);
  VK_NUMLOCK*              = 144 (* {4, 7} *);
  VK_SCROLL*               = 145 (* {0, 4, 7} *);
  VK_LSHIFT*               = 160 (* {5, 7} *);
  VK_RSHIFT*               = 161 (* {0, 5, 7} *);
  VK_LCONTROL*             = 162 (* {1, 5, 7} *);
  VK_RCONTROL*             = 163 (* {0, 1, 5, 7} *);
  VK_LMENU*                = 164 (* {2, 5, 7} *);
  VK_RMENU*                = 165 (* {0, 2, 5, 7} *);
  VK_PROCESSKEY*           = 229 (* {0, 2, 5..7} *);
  VK_ATTN*                 = 246 (* {1, 2, 4..7} *);
  VK_CRSEL*                = 247 (* {0..2, 4..7} *);
  VK_EXSEL*                = 248 (* {3..7} *);
  VK_EREOF*                = 249 (* {0, 3..7} *);
  VK_PLAY*                 = 250 (* {1, 3..7} *);
  VK_ZOOM*                 = 251 (* {0, 1, 3..7} *);
  VK_NONAME*               = 252 (* {2..7} *);
  VK_PA1*                  = 253 (* {0, 2..7} *);
  VK_OEM_CLEAR*            = 254 (* {1..7} *);

  TME_HOVER*               = 00001H;
  TME_LEAVE*               = 00002H;

  TRANSPARENT*             = 1;
  OPAQUE*                  = 2;

  WA_INACTIVE*                      = 0;
  WA_ACTIVE*                        = 1;
  WA_CLICKACTIVE*                   = 2;

  WM_NULL*                          = 00000H;
  WM_CREATE*                        = 00001H;
  WM_DESTROY*                       = 00002H;
  WM_MOVE*                          = 00003H;
  WM_SIZE*                          = 00005H;
  WM_ACTIVATE*                      = 00006H;
  WM_SETFOCUS*                      = 00007H;
  WM_KILLFOCUS*                     = 00008H;
  WM_ENABLE*                        = 0000AH;
  WM_SETREDRAW*                     = 0000BH;
  WM_SETTEXT*                       = 0000CH;
  WM_GETTEXT*                       = 0000DH;
  WM_GETTEXTLENGTH*                 = 0000EH;
  WM_PAINT*                         = 0000FH;
  WM_CLOSE*                         = 00010H;
  WM_QUERYENDSESSION*               = 00011H;
  WM_QUIT*                          = 00012H;
  WM_QUERYOPEN*                     = 00013H;
  WM_ERASEBKGND*                    = 00014H;
  WM_SYSCOLORCHANGE*                = 00015H;
  WM_ENDSESSION*                    = 00016H;
  WM_SYSTEMERROR*                   = 00017H;
  WM_SHOWWINDOW*                    = 00018H;
  WM_CTLCOLOR*                      = 00019H;
  WM_WININICHANGE*                  = 0001AH;
  WM_SETTINGCHANGE*                 = WM_WININICHANGE;
  WM_DEVMODECHANGE*                 = 0001BH;
  WM_ACTIVATEAPP*                   = 0001CH;
  WM_FONTCHANGE*                    = 0001DH;
  WM_TIMECHANGE*                    = 0001EH;
  WM_CANCELMODE*                    = 0001FH;
  WM_SETCURSOR*                     = 00020H;
  WM_MOUSEACTIVATE*                 = 00021H;
  WM_CHILDACTIVATE*                 = 00022H;
  WM_QUEUESYNC*                     = 00023H;
  WM_GETMINMAXINFO*                 = 00024H;
  WM_PAINTICON*                     = 00026H;
  WM_ICONERASEBKGND*                = 00027H;
  WM_NEXTDLGCTL*                    = 00028H;
  WM_SPOOLERSTATUS*                 = 0002AH;
  WM_DRAWITEM*                      = 0002BH;
  WM_MEASUREITEM*                   = 0002CH;
  WM_DELETEITEM*                    = 0002DH;
  WM_VKEYTOITEM*                    = 0002EH;
  WM_CHARTOITEM*                    = 0002FH;
  WM_SETFONT*                       = 00030H;
  WM_GETFONT*                       = 00031H;
  WM_SETHOTKEY*                     = 00032H;
  WM_GETHOTKEY*                     = 00033H;
  WM_QUERYDRAGICON*                 = 00037H;
  WM_COMPAREITEM*                   = 00039H;
  WM_GETOBJECT*                     = 0003DH;
  WM_COMPACTING*                    = 00041H;
  WM_COMMNOTIFY*                    = 00044H;
  WM_WINDOWPOSCHANGING*             = 00046H;
  WM_WINDOWPOSCHANGED*              = 00047H;
  WM_POWER*                         = 00048H;
  WM_COPYDATA*                      = 0004AH;
  WM_CANCELJOURNAL*                 = 0004BH;
  WM_NOTIFY*                        = 0004EH;
  WM_INPUTLANGCHANGEREQUEST*        = 00050H;
  WM_INPUTLANGCHANGE*               = 00051H;
  WM_TCARD*                         = 00052H;
  WM_HELP*                          = 00053H;
  WM_USERCHANGED*                   = 00054H;
  WM_NOTIFYFORMAT*                  = 00055H;
  WM_CONTEXTMENU*                   = 0007BH;
  WM_STYLECHANGING*                 = 0007CH;
  WM_STYLECHANGED*                  = 0007DH;
  WM_DISPLAYCHANGE*                 = 0007EH;
  WM_GETICON*                       = 0007FH;
  WM_SETICON*                       = 00080H;
  WM_NCCREATE*                      = 00081H;
  WM_NCDESTROY*                     = 00082H;
  WM_NCCALCSIZE*                    = 00083H;
  WM_NCHITTEST*                     = 00084H;
  WM_NCPAINT*                       = 00085H;
  WM_NCACTIVATE*                    = 00086H;
  WM_GETDLGCODE*                    = 00087H;
  WM_NCMOUSEMOVE*                   = 000A0H;
  WM_NCLBUTTONDOWN*                 = 000A1H;
  WM_NCLBUTTONUP*                   = 000A2H;
  WM_NCLBUTTONDBLCLK*               = 000A3H;
  WM_NCRBUTTONDOWN*                 = 000A4H;
  WM_NCRBUTTONUP*                   = 000A5H;
  WM_NCRBUTTONDBLCLK*               = 000A6H;
  WM_NCMBUTTONDOWN*                 = 000A7H;
  WM_NCMBUTTONUP*                   = 000A8H;
  WM_NCMBUTTONDBLCLK*               = 000A9H;
  WM_NCXBUTTONDOWN*                 = 000ABH;
  WM_NCXBUTTONUP*                   = 000ACH;
  WM_NCXBUTTONDBLCLK*               = 000ADH;
  WM_INPUT*                         = 000FFH;
  WM_KEYFIRST*                      = 00100H;
  WM_KEYDOWN*                       = 00100H;
  WM_KEYUP*                         = 00101H;
  WM_CHAR*                          = 00102H;
  WM_DEADCHAR*                      = 00103H;
  WM_SYSKEYDOWN*                    = 00104H;
  WM_SYSKEYUP*                      = 00105H;
  WM_SYSCHAR*                       = 00106H;
  WM_SYSDEADCHAR*                   = 00107H;
  WM_UNICHAR*                       = 00109H;
  WM_KEYLAST*                       = 00109H;
  WM_INITDIALOG*                    = 00110H;
  WM_COMMAND*                       = 00111H;
  WM_SYSCOMMAND*                    = 00112H;
  WM_TIMER*                         = 00113H;
  WM_HSCROLL*                       = 00114H;
  WM_VSCROLL*                       = 00115H;
  WM_INITMENU*                      = 00116H;
  WM_INITMENUPOPUP*                 = 00117H;
  WM_MENUSELECT*                    = 0011FH;
  WM_MENUCHAR*                      = 00120H;
  WM_ENTERIDLE*                     = 00121H;
  WM_MENURBUTTONUP*                 = 00122H;
  WM_MENUDRAG*                      = 00123H;
  WM_MENUGETOBJECT*                 = 00124H;
  WM_UNINITMENUPOPUP*               = 00125H;
  WM_MENUCOMMAND*                   = 00126H;
  WM_CHANGEUISTATE*                 = 00127H;
  WM_UPDATEUISTATE*                 = 00128H;
  WM_QUERYUISTATE*                  = 00129H;
  WM_CTLCOLORMSGBOX*                = 00132H;
  WM_CTLCOLOREDIT*                  = 00133H;
  WM_CTLCOLORLISTBOX*               = 00134H;
  WM_CTLCOLORBTN*                   = 00135H;
  WM_CTLCOLORDLG*                   = 00136H;
  WM_CTLCOLORSCROLLBAR*             = 00137H;
  WM_CTLCOLORSTATIC*                = 00138H;
  WM_MOUSEFIRST*                    = 00200H;
  WM_MOUSEMOVE*                     = 00200H;
  WM_LBUTTONDOWN*                   = 00201H;
  WM_LBUTTONUP*                     = 00202H;
  WM_LBUTTONDBLCLK*                 = 00203H;
  WM_RBUTTONDOWN*                   = 00204H;
  WM_RBUTTONUP*                     = 00205H;
  WM_RBUTTONDBLCLK*                 = 00206H;
  WM_MBUTTONDOWN*                   = 00207H;
  WM_MBUTTONUP*                     = 00208H;
  WM_MBUTTONDBLCLK*                 = 00209H;
  WM_MOUSEWHEEL*                    = 0020AH;
  WM_MOUSELAST*                     = 0020AH;
  WM_PARENTNOTIFY*                  = 00210H;
  WM_ENTERMENULOOP*                 = 00211H;
  WM_EXITMENULOOP*                  = 00212H;
  WM_NEXTMENU*                      = 00213H;
  WM_SIZING*                        = 532;
  WM_CAPTURECHANGED*                = 533;
  WM_MOVING*                        = 534;
  WM_POWERBROADCAST*                = 536;
  WM_DEVICECHANGE*                  = 537;
  WM_IME_STARTCOMPOSITION*          = 0010DH;
  WM_IME_ENDCOMPOSITION*            = 0010EH;
  WM_IME_COMPOSITION*               = 0010FH;
  WM_IME_KEYLAST*                   = 0010FH;
  WM_IME_SETCONTEXT*                = 00281H;
  WM_IME_NOTIFY*                    = 00282H;
  WM_IME_CONTROL*                   = 00283H;
  WM_IME_COMPOSITIONFULL*           = 00284H;
  WM_IME_SELECT*                    = 00285H;
  WM_IME_CHAR*                      = 00286H;
  WM_IME_REQUEST*                   = 00288H;
  WM_IME_KEYDOWN*                   = 00290H;
  WM_IME_KEYUP*                     = 00291H;
  WM_MDICREATE*                     = 00220H;
  WM_MDIDESTROY*                    = 00221H;
  WM_MDIACTIVATE*                   = 00222H;
  WM_MDIRESTORE*                    = 00223H;
  WM_MDINEXT*                       = 00224H;
  WM_MDIMAXIMIZE*                   = 00225H;
  WM_MDITILE*                       = 00226H;
  WM_MDICASCADE*                    = 00227H;
  WM_MDIICONARRANGE*                = 00228H;
  WM_MDIGETACTIVE*                  = 00229H;
  WM_MDISETMENU*                    = 00230H;
  WM_ENTERSIZEMOVE*                 = 00231H;
  WM_EXITSIZEMOVE*                  = 00232H;
  WM_DROPFILES*                     = 00233H;
  WM_MDIREFRESHMENU*                = 00234H;
  WM_MOUSEHOVER*                    = 002A1H;
  WM_MOUSELEAVE*                    = 002A3H;
  WM_NCMOUSEHOVER*                  = 002A0H;
  WM_NCMOUSELEAVE*                  = 002A2H;
  WM_WTSSESSION_CHANGE*             = 002B1H;
  WM_TABLET_FIRST*                  = 002C0H;
  WM_TABLET_LAST*                   = 002DFH;
  WM_CUT*                           = 00300H;
  WM_COPY*                          = 00301H;
  WM_PASTE*                         = 00302H;
  WM_CLEAR*                         = 00303H;
  WM_UNDO*                          = 00304H;
  WM_RENDERFORMAT*                  = 00305H;
  WM_RENDERALLFORMATS*              = 00306H;
  WM_DESTROYCLIPBOARD*              = 00307H;
  WM_DRAWCLIPBOARD*                 = 00308H;
  WM_PAINTCLIPBOARD*                = 00309H;
  WM_VSCROLLCLIPBOARD*              = 0030AH;
  WM_SIZECLIPBOARD*                 = 0030BH;
  WM_ASKCBFORMATNAME*               = 0030CH;
  WM_CHANGECBCHAIN*                 = 0030DH;
  WM_HSCROLLCLIPBOARD*              = 0030EH;
  WM_QUERYNEWPALETTE*               = 0030FH;
  WM_PALETTEISCHANGING*             = 00310H;
  WM_PALETTECHANGED*                = 00311H;
  WM_HOTKEY*                        = 00312H;
  WM_PRINT*                         = 791;
  WM_PRINTCLIENT*                   = 792;
  WM_APPCOMMAND*                    = 00319H;
  WM_THEMECHANGED*                  = 0031AH;
  WM_HANDHELDFIRST*                 = 856;
  WM_HANDHELDLAST*                  = 863;
  WM_PENWINFIRST*                   = 00380H;
  WM_PENWINLAST*                    = 0038FH;
  WM_COALESCE_FIRST*                = 00390H;
  WM_COALESCE_LAST*                 = 0039FH;
  WM_DDE_FIRST*                     = 003E0H;
  WM_DDE_INITIATE*                  = WM_DDE_FIRST + 0;
  WM_DDE_TERMINATE*                 = WM_DDE_FIRST + 1;
  WM_DDE_ADVISE*                    = WM_DDE_FIRST + 2;
  WM_DDE_UNADVISE*                  = WM_DDE_FIRST + 3;
  WM_DDE_ACK*                       = WM_DDE_FIRST + 4;
  WM_DDE_DATA*                      = WM_DDE_FIRST + 5;
  WM_DDE_REQUEST*                   = WM_DDE_FIRST + 6;
  WM_DDE_POKE*                      = WM_DDE_FIRST + 7;
  WM_DDE_EXECUTE*                   = WM_DDE_FIRST + 8;
  WM_DDE_LAST*                      = WM_DDE_FIRST + 8;
  WM_APP*                           = 08000H;
  WM_USER*                          = 00400H;

  WS_OVERLAPPED*           = {};
  WS_POPUP*                = {31};
  WS_CHILD*                = {30};
  WS_MINIMIZE*             = {29};
  WS_VISIBLE*              = {28};
  WS_DISABLED*             = {27};
  WS_CLIPSIBLINGS*         = {26};
  WS_CLIPCHILDREN*         = {25};
  WS_MAXIMIZE*             = {24};
  WS_CAPTION*              = {22, 23};
  WS_BORDER*               = {23};
  WS_DLGFRAME*             = {22};
  WS_VSCROLL*              = {21};
  WS_HSCROLL*              = {20};
  WS_SYSMENU*              = {19};
  WS_THICKFRAME*           = {18};
  WS_GROUP*                = {17};
  WS_TABSTOP*              = {16};
  WS_MINIMIZEBOX*          = {17};
  WS_MAXIMIZEBOX*          = {16};
  WS_TILED*                = {};
  WS_ICONIC*               = {29};
  WS_SIZEBOX*              = {18};
  WS_TILEDWINDOW*          = {16..19, 22, 23};
  WS_OVERLAPPEDWINDOW*     = {16..19, 22, 23};
  WS_POPUPWINDOW*          = {19, 23, 31};
  WS_CHILDWINDOW*          = {30};

  WS_EX_DLGMODALFRAME*     = {0};
  WS_EX_NOPARENTNOTIFY*    = {2};
  WS_EX_TOPMOST*           = {3};
  WS_EX_ACCEPTFILES*       = {4};
  WS_EX_TRANSPARENT*       = {5};
  WS_EX_MDICHILD*          = {6};
  WS_EX_TOOLWINDOW*        = {7};
  WS_EX_WINDOWEDGE*        = {8};
  WS_EX_CLIENTEDGE*        = {9};
  WS_EX_CONTEXTHELP*       = {10};
  WS_EX_RIGHT*             = {12};
  WS_EX_LEFT*              = {};
  WS_EX_RTLREADING*        = {13};
  WS_EX_LTRREADING*        = {};
  WS_EX_LEFTSCROLLBAR*     = {14};
  WS_EX_RIGHTSCROLLBAR*    = {};
  WS_EX_CONTROLPARENT*     = {16};
  WS_EX_STATICEDGE*        = {17};
  WS_EX_APPWINDOW*         = {18};
  WS_EX_OVERLAPPEDWINDOW*  = {8, 9};
  WS_EX_PALETTEWINDOW*     = {3, 7, 8};
  WS_EX_COMPOSITED*        = {25};
  WS_EX_NOACTIVATE*        = {27};

  DEFAULT_CHARSET*         = 1;
  SYMBOL_CHARSET*          = 2;
  SHIFTJIS_CHARSET*        = 128;
  HANGEUL_CHARSET*         = 129;
  GB2312_CHARSET*          = 134;
  CHINESEBIG5_CHARSET*     = 136;
  OEM_CHARSET*             = 255;
  JOHAB_CHARSET*           = 130;
  HEBREW_CHARSET*          = 177;
  ARABIC_CHARSET*          = 178;
  GREEK_CHARSET*           = 161;
  TURKISH_CHARSET*         = 162;
  THAI_CHARSET*            = 222;
  EASTEUROPE_CHARSET*      = 238;
  RUSSIAN_CHARSET*         = 204;
  MAC_CHARSET*             = 77;
  BALTIC_CHARSET*          = 186;

  DEFAULT_QUALITY*         = 0;
  DRAFT_QUALITY*           = 1;
  PROOF_QUALITY*           = 2;
  NONANTIALIASED_QUALITY*  = 3;
  ANTIALIASED_QUALITY*     = 4;
  DEFAULT_PITCH*           = 0;
  FIXED_PITCH*             = 1;
  VARIABLE_PITCH*          = 2;
  MONO_FONT*               = 8;

  CLIP_DEFAULT_PRECIS*     = 0;
  CLIP_CHARACTER_PRECIS*   = 1;
  CLIP_STROKE_PRECIS*      = 2;
  CLIP_MASK*               = 15;
  CLIP_LH_ANGLES*          = 16;
  CLIP_TT_ALWAYS*          = 32;
  CLIP_EMBEDDED*           = 128;

  OUT_DEFAULT_PRECIS*      = 0;
  OUT_STRING_PRECIS*       = 1;
  OUT_CHARACTER_PRECIS*    = 2;
  OUT_STROKE_PRECIS*       = 3;
  OUT_TT_PRECIS*           = 4;
  OUT_DEVICE_PRECIS*       = 5;
  OUT_RASTER_PRECIS*       = 6;
  OUT_TT_ONLY_PRECIS*      = 7;
  OUT_OUTLINE_PRECIS*      = 8;

  PD_ALLPAGES*                   = {};
  PD_SELECTION*                  = {0};
  PD_PAGENUMS*                   = {1};
  PD_NOSELECTION*                = {2};
  PD_NOPAGENUMS*                 = {3};
  PD_COLLATE*                    = {4};
  PD_PRINTTOFILE*                = {5};
  PD_PRINTSETUP*                 = {6};
  PD_NOWARNING*                  = {7};
  PD_RETURNDC*                   = {8};
  PD_RETURNIC*                   = {9};
  PD_RETURNDEFAULT*              = {10};
  PD_SHOWHELP*                   = {11};
  PD_ENABLEPRINTHOOK*            = {12};
  PD_ENABLESETUPHOOK*            = {13};
  PD_ENABLEPRINTTEMPLATE*        = {14};
  PD_ENABLESETUPTEMPLATE*        = {15};
  PD_ENABLEPRINTTEMPLATEHANDLE*  = {16};
  PD_ENABLESETUPTEMPLATEHANDLE*  = {17};
  PD_USEDEVMODECOPIES*           = {18};
  PD_USEDEVMODECOPIESANDCOLLATE* = {18};
  PD_DISABLEPRINTTOFILE*         = {19};
  PD_HIDEPRINTTOFILE*            = {20};
  PD_NONETWORKBUTTON*            = {21};

TYPE
  BOOL*      = LONGINT;
  ADDRESS*   = LONGINT;
  HANDLE*    = ADDRESS;
  HMODULE*   = ADDRESS;
  HINSTANCE* = ADDRESS;
  ATOM*      = INTEGER;
  HGLOBAL*   = HANDLE;
  LPSTR*     = ADDRESS;
  HWND*      = HANDLE;
  HDC*       = HANDLE;
  HGDIObj*   = HANDLE;
  HFont*     = HGDIObj;
  HBrush*    = HGDIObj;
  HPen*      = HGDIObj;
  HRgn*      = HGDIObj;
  HBitmap*   = HGDIObj;
  HIcon*     = HANDLE;
  HCursor*   = HANDLE;
  HMenu*     = HANDLE;
  HPalette*  = HANDLE;
  HAccel*    = HANDLE;
  HHook*     = HANDLE;

  WParam*    = LONGINT;
  LParam*    = LONGINT;
  LResult*   = LONGINT;

  ColorRef* = LONGINT;

  Point* = RECORD [NOTAG]
    x*             : LONGINT;
    y*             : LONGINT;
  END;

  Rect* = RECORD [NOTAG]
    left*          : LONGINT;
    top*           : LONGINT;
    right*         : LONGINT;
    bottom*        : LONGINT;
  END;

  Size* = RECORD [NOTAG]
    cx*            : LONGINT;
    cy*            : LONGINT;
  END;

  Msg* = RECORD [NOTAG]
    hwnd*          : HWND;
    message*       : LONGINT;
    wParam*        : LONGINT;
    lParam*        : LONGINT;
    time*          : LONGINT;
    point*         : Point;
  END;

  WndClassEx* = RECORD [NOTAG]
    cbSize*        : LONGINT;
    style*         : SET;
    lpfnWndProc*   : DefWindowProc;
    cbClsExtra*    : LONGINT;
    cbWndExtra*    : LONGINT;
    hInstance*     : HINSTANCE;
    hIcon*         : HIcon;
    hCursor*       : HCursor;
    hbrBackground* : HBrush;
    lpszMenuName*  : LPSTR;
    lpszClassName* : LPSTR;
    hIconSm*       : HIcon;
  END;

  TrackMouseEventEx* =  RECORD [NOTAG]
    cbSize*        : LONGINT;
    dwFlags*       : LONGINT;
    hwndTrack*     : HWND;
    dwHoverTime*   : LONGINT;
  END;

  PaintStruct* =  RECORD [NOTAG]
    hdc*           : HDC;
    fErase*        : BOOL;
    rcPaint*       : Rect;
    fRestore*      : BOOL;
    fIncUpdate*    : BOOL;
    rgbReserved*   : ARRAY [NOTAG] 32 OF CHAR;
  END;

  LogFontA* =  RECORD [NOTAG]
    lfHeight*      : LONGINT;
    lfWidth*       : LONGINT;
    lfEscapement*  : LONGINT;
    lfOrientation* : LONGINT;
    lfWeight*      : LONGINT;
    lfItalic*      : CHAR;
    lfUnderline*   : CHAR;
    lfStrikeOut*   : CHAR;
    lfCharSet*     : CHAR;
    lfOutPrecision*: CHAR;
    lfClipPrecision*: CHAR;
    lfQuality*      : CHAR;
    lfPitchAndFamily*: CHAR;
    lfFaceName*: ARRAY [NOTAG] 32 OF CHAR;
  END;

  LogFont* =  RECORD [NOTAG]
    lfHeight*      : LONGINT;
    lfWidth*       : LONGINT;
    lfEscapement*  : LONGINT;
    lfOrientation* : LONGINT;
    lfWeight*      : LONGINT;
    lfItalic*      : LONGINT;
    lfUnderline*   : LONGINT;
    lfStrikeOut*   : LONGINT;
    lfCharSet*     : LONGINT;
    lfOutPrecision*: LONGINT;
    lfClipPrecision*: LONGINT;
    lfQuality*     : LONGINT;
    lfPitchAndFamily*: LONGINT;
    lfFaceName*    : LPSTR;
  END;

  BitmapInfoHeader* = RECORD [NOTAG]
    biSize*        : LONGINT;
    biWidth*       : LONGINT;
    biHeight*      : LONGINT;
    biPlanes*      : INTEGER;
    biBitCount*    : INTEGER;
    biCompression* : LONGINT;
    biSizeImage*   : LONGINT;
    biXPelsPerMeter*: LONGINT;
    biYPelsPerMeter*: LONGINT;
    biClrUsed*     : LONGINT;
    biClrImportant*: LONGINT
  END;

  RGBQuad* = RECORD [NOTAG]
    rgbBlue*       : CHAR;
    rgbGreen*      : CHAR;
    rgbRed*        : CHAR;
    rgbReserved*   : CHAR;
  END;

  BitmapInfo* = RECORD [NOTAG]
    bmiHeader*     : BitmapInfoHeader;
    bmiColors*     : ARRAY [NOTAG] 1 OF RGBQuad;
  END;

  Bitmap* = RECORD [NOTAG]
    bmType*        : LONGINT;
    bmWidth*       : LONGINT;
    bmHeight*      : LONGINT;
    bmWidthBytes*  : LONGINT;
    bmPlanes*      : INTEGER;
    bmBitsPixel*   : INTEGER;
    bmBits*        : LONGINT;
  END;

  OpenFileNameA*  = RECORD  [NOTAG]
    lStructSize*       : LONGINT;
    hwndOwner*         : HWND;
    hInstance*         : HINSTANCE;
    lpstrFilter*       : LPSTR;
    lpstrCustomFilter* : LPSTR;
    nMaxCustFilter*    : LONGINT;
    nFilterIndex*      : LONGINT;
    lpstrFile*         : LPSTR;
    nMaxFile*          : LONGINT;
    lpstrFileTitle*    : LPSTR;
    nMaxFileTitle*     : LONGINT;
    lpstrInitialDir*   : LPSTR;
    lpstrTitle*        : LPSTR;
    Flags*             : SET;
    nFileOffset*       : INTEGER;
    nFileExtension*    : INTEGER;
    lpstrDefExt*       : LPSTR;
    lCustData*         : LParam;
    lpfnHook*          : DefWindowProc;
    lpTemplateName*    : LPSTR;
  END;

  ChooseColorA* = RECORD [NOTAG]
    lStructSize*       : LONGINT;
    hwndOwner*         : HWND;
    hInstance*         : HWND;
    rgbResult*         : ColorRef;
    lpCustColors*      : LONGINT;
    Flags*             : SET;
    lCustData*         : LParam;
    lpfnHook*          : DefWindowProc;
    lpTemplateName*    : LPSTR;
  END;

  PrintDlgA* = RECORD [NOTAG]
    lStructSize*       : LONGINT;
    hwndOwner*         : HWND;
    hDevMode*          : HGLOBAL;
    hDevNames*         : HGLOBAL;
    hDC*               : HDC;
    Flags*             : SET;
    nFromPage*         : INTEGER;
    nToPage*           : INTEGER;
    nMinPage*          : INTEGER;
    nMaxPage*          : INTEGER;
    nCopies*           : INTEGER;
    hInstance*         : HINSTANCE;
    lCustData*         : LParam;
    lpfnPrintHook*     : DefWindowProc;
    lpfnSetupHook*     : DefWindowProc;
    lpPrintTemplateName*: LPSTR;
    lpSetupTemplateName*: LPSTR;
    hPrintTemplate*    : HGLOBAL;
    hSetupTemplate*    : HGLOBAL;
  END;

  ChooseFontA* = RECORD [NOTAG]
    lStructSize*       : LONGINT;
    hwndOwner*         : HWND;
    hDC*               : HDC;
    lpLogFont*         : LONGINT;
    iPointSize*        : LONGINT;
    Flags*             : SET;
    rgbColors*         : ColorRef;
    lCustData*         : LParam;
    lpfnHook*          : DefWindowProc;
    lpTemplateName*    : LPSTR;
    hInstance*         : HINSTANCE;
    lpszStyle*         : LPSTR;
    nFontType*         : INTEGER;
    ___MISSING_ALIGNMENT__*: INTEGER;
    nSizeMin*          : LONGINT;
    nSizeMax*          : LONGINT;
  END;

  TimerProc* = PROCEDURE [WINAPI] (hwnd: HWND; uMsg, idEvent, dwTime: LONGINT): LONGINT;

VAR
  mod: Longint;
  str: Name;
  hInstance-: Longint;

  HeapCreate-             : PROCEDURE [WINAPI] (flOptions: SET; dwInitialSize: LONGINT; dwMaximumSize: LONGINT): HANDLE;
  HeapDestroy-            : PROCEDURE [WINAPI] (hHeap: HANDLE): BOOL;
  HeapAlloc-              : PROCEDURE [WINAPI] (hHeap: HANDLE; dwFlags: SET; dwBytes: LONGINT): LONGINT;
  HeapReAlloc-            : PROCEDURE [WINAPI] (hHeap: HANDLE; dwFlags: SET; lpMem: LONGINT; dwBytes: LONGINT): LONGINT;
  HeapFree-               : PROCEDURE [WINAPI] (hHeap: HANDLE; dwFlags: SET; lpMem: LONGINT): BOOL;
  HeapSize-               : PROCEDURE [WINAPI] (hHeap: HANDLE; dwFlags: SET; lpMem: LONGINT): LONGINT;

  GlobalAlloc-            : PROCEDURE [WINAPI] (uFlags: SET; dwBytes: LONGINT): HGLOBAL;
  GlobalReAlloc-          : PROCEDURE [WINAPI] (hMem: HGLOBAL; dwBytes: LONGINT; uFlags: SET): HGLOBAL;
  GlobalSize-             : PROCEDURE [WINAPI] (hMem: HGLOBAL): LONGINT;
  GlobalLock-             : PROCEDURE [WINAPI] (hMem: HGLOBAL): LONGINT;
  GlobalUnlock-           : PROCEDURE [WINAPI] (hMem: HGLOBAL): BOOL;
  GlobalFree-             : PROCEDURE [WINAPI] (hMem: HGLOBAL): HGLOBAL;

  AdjustWindowRectEx-     : PROCEDURE [WINAPI] (VAR lpRect: Rect; dwStyle: SET; bMenu: BOOL; dwExStyle: SET): BOOL;
  CreateFontIndirect-     : PROCEDURE [WINAPI] (VAR p0: LogFontA): HFont;
  ClientToScreen-         : PROCEDURE [WINAPI] (hWnd: HWND; VAR lpPoint: Point): BOOL;
  CloseClipboard-         : PROCEDURE [WINAPI] (): BOOL;
  CreateCaret-            : PROCEDURE [WINAPI] (hWnd: HWND; hBitmap: HBitmap; nWidth: LONGINT; nHeight: LONGINT): BOOL;
  CreateWindowEx-         : PROCEDURE [WINAPI] (dwExStyle: SET; lpClassName, lpWindowName: ARRAY [NOTAG] OF CHAR; dwStyle: SET; x, y, nWidth, nHeight: LONGINT; hWndParent: HWND; hMenu: HMenu; hInstance: HINSTANCE; lpParam: LONGINT): HWND;
  DefWindowProc-          : PROCEDURE [WINAPI] (hwnd: HWND; uMsg: LONGINT; wParam: WParam; lParam: LParam): LResult;
  DestroyCaret-           : PROCEDURE [WINAPI] (): BOOL;
  DestroyWindow-          : PROCEDURE [WINAPI] (hWnd: HWND): BOOL;
  DispatchMessage-        : PROCEDURE [WINAPI] (VAR lpMsg: Msg): LONGINT;
  EmptyClipboard-         : PROCEDURE [WINAPI] (): BOOL;
  EnableWindow-           : PROCEDURE [WINAPI] (hWnd: HWND; bEnable: BOOL): BOOL;
  FillRect-               : PROCEDURE [WINAPI] (hDC: HDC; VAR lprc: Rect; hbr: HBrush): LONGINT;
  GetActiveWindow-        : PROCEDURE [WINAPI] (): HWND;
  GetClassLong-           : PROCEDURE [WINAPI] (hWnd: HWND; nIndex: LONGINT): LONGINT;
  GetClientRect-          : PROCEDURE [WINAPI] (hWnd: HWND; VAR lpRect: Rect): BOOL;
  GetClipboardData-       : PROCEDURE [WINAPI] (uFormat: LONGINT): HANDLE;
  GetCursorPos-           : PROCEDURE [WINAPI] (VAR lpPoint: Point): BOOL;
  GetDC-                  : PROCEDURE [WINAPI] (hWnd: HWND): HDC;
  GetFocus-               : PROCEDURE [WINAPI] (): HWND;
  GetMessage-             : PROCEDURE [WINAPI] (VAR lpMsg: Msg; hWnd: HWND; wMsgFilterMin, wMsgFilterMax: LONGINT): LONGINT;
  GetProp-                : PROCEDURE [WINAPI] (hWnd: HWND; lpString: LPSTR): HANDLE;
  GetSysColor-            : PROCEDURE [WINAPI] (nIndex: LONGINT): LONGINT;
  GetWindowRect-          : PROCEDURE [WINAPI] (hWnd: HWND; VAR lpRect: Rect): BOOL;
  HideCaret-              : PROCEDURE [WINAPI] (hWnd: HWND): BOOL;
  InvalidateRect-         : PROCEDURE [WINAPI] (hWnd: HWND; lpRect: Rect; bErase: BOOL): BOOL;
  KillTimer-              : PROCEDURE [WINAPI] (hWnd: HWND; uIDEvent: LONGINT): BOOL;
  LoadCursor-             : PROCEDURE [WINAPI] (hInstance: HINSTANCE; lpCursorName: LPSTR): HCursor;
  LoadIcon-               : PROCEDURE [WINAPI] (hInstance: HINSTANCE; lpIconName: LPSTR): HIcon;
  LoadImage-              : PROCEDURE [WINAPI] (p0: HINSTANCE; p1: LPSTR; p2: LONGINT; p3: LONGINT; p4: LONGINT; p5: SET): HANDLE;
  MessageBox-             : PROCEDURE [WINAPI] (hwnd: HWND; text, caption: ARRAY [NOTAG] OF CHAR; type: SET): LONGINT;
  MoveWindow-             : PROCEDURE [WINAPI] (hWnd: HWND; X, Y, nWidth, nHeight: LONGINT; bRepaint: BOOL): BOOL;
  OpenClipboard-          : PROCEDURE [WINAPI] (hWndNewOwner: HWND): BOOL;
  PostQuitMessage-        : PROCEDURE [WINAPI] (nExitCode: LONGINT);
  RegisterClassEx-        : PROCEDURE [WINAPI] (VAR lpwcx: WndClassEx): ATOM;
  ReleaseCapture-         : PROCEDURE [WINAPI] (): BOOL;
  ReleaseDC-              : PROCEDURE [WINAPI] (hWnd: HWND; hDC: HDC): LONGINT;
  SetCaretPos-            : PROCEDURE [WINAPI] (X: LONGINT; Y: LONGINT): BOOL;
  SetCapture-             : PROCEDURE [WINAPI] (hWnd: HWND): HWND;
  ScreenToClient-         : PROCEDURE [WINAPI] (hWnd: HWND; VAR lpPoint: Point): BOOL;
  SendMessage-            : PROCEDURE [WINAPI] (hWnd: HWND; Msg: LONGINT; wParam: WParam; lParam: LParam): LResult;
  SetClassLong-           : PROCEDURE [WINAPI] (hWnd: HWND; nIndex: LONGINT; dwNewLong: LONGINT): LONGINT;
  SetClipboardData-       : PROCEDURE [WINAPI] (uFormat: LONGINT; hMem: HANDLE): HANDLE;
  SetCursor-              : PROCEDURE [WINAPI] (hCursor: HCursor): HCursor;
  SetFocus-               : PROCEDURE [WINAPI] (hWnd: HWND): HWND;
  SetProp-                : PROCEDURE [WINAPI] (hWnd: HWND; lpString: LPSTR; hData: HANDLE): BOOL;
  SetTimer-               : PROCEDURE [WINAPI] (hWnd: HWND; nIDEvent: LONGINT; uElapse: LONGINT; lpTimerFunc: TimerProc): LONGINT;
  SetWindowLong-          : PROCEDURE [WINAPI] (hWnd: HWND; nIndex: LONGINT; dwNewLong: SET): LONGINT;
  SetWindowPos-           : PROCEDURE [WINAPI] (hWnd, hWndInsertAfter: HWND; X, Y, cx, cy: LONGINT; uFlags: SET): BOOL;
  SetWindowRgn-           : PROCEDURE [WINAPI] (hWnd: HWND; hRgn: HRgn; bRedraw: BOOL): LONGINT;
  ShowCaret-              : PROCEDURE [WINAPI] (hWnd: HWND): BOOL;
  SystemParametersInfo-   : PROCEDURE [WINAPI] (uiAction: LONGINT; uiParam: LONGINT; pvParam: LONGINT; fWinIni: LONGINT): BOOL;
  ShowWindow-             : PROCEDURE [WINAPI] (hWnd: HWND; nCmdShow: LONGINT): BOOL;
  TrackMouseEvent-        : PROCEDURE [WINAPI] (VAR EventTrack: TrackMouseEventEx): BOOL;
  TranslateMessage-       : PROCEDURE [WINAPI] (VAR lpMsg: Msg): BOOL;
  UpdateWindow-           : PROCEDURE [WINAPI] (hWnd: HWND): BOOL;
  UnregisterClass-        : PROCEDURE [WINAPI] (lpClassName: ARRAY [NOTAG] OF CHAR; hInstance: HINSTANCE): BOOL;

  Arc-                    : PROCEDURE [WINAPI] (p0: HDC; p1: LONGINT; p2: LONGINT; p3: LONGINT; p4: LONGINT; p5: LONGINT; p6: LONGINT; p7: LONGINT; p8: LONGINT): BOOL;
  BitBlt-                 : PROCEDURE [WINAPI] (hdcDest: HDC;  nXDest, nYDest, nWidth, nHeight: LONGINT;  hdcSrc: HDC;  nXSrc, nYSrc, dwRop: LONGINT): BOOL;
  CombineRgn-             : PROCEDURE [WINAPI] (p1, p2, p3: HRgn; p4: LONGINT): LONGINT;
  CreateCompatibleDC-     : PROCEDURE [WINAPI] (hdc: HDC): HDC;
  CreateDIBSection-       : PROCEDURE [WINAPI] (hdc: HDC; VAR lpbi: BitmapInfo; iUsage: LONGINT; VAR adr: LONGINT; hSection: LONGINT; dwOffset: LONGINT): HBitmap;
  CreateFont-             : PROCEDURE [WINAPI] (p0:  LONGINT; p1:  LONGINT; p2:  LONGINT; p3: LONGINT; p4:  LONGINT; p5:  LONGINT; p6:  LONGINT; p7: LONGINT; p8: LONGINT; p9: LONGINT; p10: LONGINT; p11: LONGINT; p12: LONGINT; p13: LPSTR): HFont;
  CreatePen-              : PROCEDURE [WINAPI] (fnPenStyle, nWidth: LONGINT;  crColor: ColorRef): HPen;
  CreateRectRgn-          : PROCEDURE [WINAPI] (nLeftRect, nTopRect, nRightRect, nBottomRect: LONGINT): HRgn;
  CreateRoundRectRgn-     : PROCEDURE [WINAPI] (p0: LONGINT; p1: LONGINT; p2: LONGINT; p3: LONGINT; p4: LONGINT; p5: LONGINT): HRgn;
  CreateSolidBrush-       : PROCEDURE [WINAPI] (crColor: ColorRef): HBrush;
  DeleteDC-               : PROCEDURE [WINAPI] (hdc: HDC): BOOL;
  DeleteObject-           : PROCEDURE [WINAPI] (hObject: HGDIObj): BOOL;
  ExtTextOut-             : PROCEDURE [WINAPI] (p0: HDC; p1: LONGINT; p2: LONGINT; p3: SET; VAR p4: Rect; p5: LPSTR; p6: LONGINT; VAR p7: LONGINT): BOOL;
  GetCharWidth-           : PROCEDURE [WINAPI] (p0: HDC; p1: LONGINT; p2: LONGINT; VAR p3: LONGINT): BOOL;
  GetDIBits-              : PROCEDURE [WINAPI] (hdc: HDC;  hbmp: HBitmap;  uStartScanLine, cScanLines: LONGINT;  lpvBits: ADDRESS;  VAR lpbi: BitmapInfo;  uUsage: LONGINT): LONGINT;
  GetObject-              : PROCEDURE [WINAPI] (p0: LONGINT; p1: LONGINT; p2: LONGINT): LONGINT;
  GetStockObject-         : PROCEDURE [WINAPI] (p0: LONGINT): HGDIObj;
  GetTextExtentPoint32-   : PROCEDURE [WINAPI] (p0: HDC; p1: LPSTR; p2: LONGINT; VAR p3: Size): BOOL;
  LineTo-                 : PROCEDURE [WINAPI] (hdc: HDC;  nXEnd, nYEnd: LONGINT): BOOL;
  MoveToEx-               : PROCEDURE [WINAPI] (hdc: HDC;  X, Y: LONGINT;  VAR lpPoint: Rect): BOOL;
  PatBlt-                 : PROCEDURE [WINAPI] (hdc: HDC;  nXLeft, nLeft, nWidth, nHeight, dwRop: LONGINT): BOOL;
  SelectObject-           : PROCEDURE [WINAPI] (hdc: HDC;  hgdiobj: HGDIObj): HGDIObj;
  SetBkMode-              : PROCEDURE [WINAPI] (p0: HDC; p1: LONGINT): LONGINT;
  SetTextColor-           : PROCEDURE [WINAPI] (p0: HDC; p1: ColorRef): ColorRef;
  StretchBlt-             : PROCEDURE [WINAPI] (p0: HDC; p1: LONGINT; p2: LONGINT; p3: LONGINT; p4: LONGINT; p5: HDC; p6: LONGINT; p7: LONGINT; p8: LONGINT; p9: LONGINT; p10: LONGINT): BOOL;

  ChooseColor-            : PROCEDURE [WINAPI] (VAR p0: ChooseColorA): BOOL;
  ChooseFont-             : PROCEDURE [WINAPI] (VAR p0: ChooseFontA): BOOL;
  GetOpenFileName-        : PROCEDURE [WINAPI] (VAR p0: OpenFileNameA): BOOL;
  GetSaveFileName-        : PROCEDURE [WINAPI] (VAR p0: OpenFileNameA): BOOL;
  PrintDlg-               : PROCEDURE [WINAPI] (VAR p0: PrintDlgA): BOOL;

PROCEDURE ExitProcess*(code: LONGINT);
BEGIN
  Kernel.Shutdown0(0);
  Kernel.ExitProcess(0);
END ExitProcess;

PROCEDURE GetTickCount*(): LONGINT;
BEGIN
  RETURN Kernel32.GetTickCount();
END GetTickCount;

PROCEDURE VirtualAlloc*(size: LONGINT): LONGINT;
BEGIN
  RETURN Kernel.VirtualAlloc(0,size,{Kernel.MEMCommit}, {Kernel.PageExecuteReadWrite});
END VirtualAlloc;

PROCEDURE VirtualFree*(adr: LONGINT);
BEGIN
  Kernel.VirtualFree(adr, 0, {Kernel.MEMRelease});
END VirtualFree;

PROCEDURE ClearWorkSize*(handle: LONGINT);
BEGIN
  Kernel32.SetProcessWorkingSetSize(handle,-1,-1);
END ClearWorkSize;

PROCEDURE Collect*;
BEGIN
  Kernel.GC;
END Collect;

BEGIN
  hInstance := Kernel.GetModuleHandle(NIL);

  str := "KERNEL32.DLL";
  mod := Kernel.LoadLibrary(str);

  Kernel.GetProcAddress(mod, "HeapCreate"            , SYSTEM.VAL(ADDRESS,HeapCreate));
  Kernel.GetProcAddress(mod, "HeapDestroy"           , SYSTEM.VAL(ADDRESS,HeapDestroy));
  Kernel.GetProcAddress(mod, "HeapAlloc"             , SYSTEM.VAL(ADDRESS,HeapAlloc));
  Kernel.GetProcAddress(mod, "HeapReAlloc"           , SYSTEM.VAL(ADDRESS,HeapReAlloc));
  Kernel.GetProcAddress(mod, "HeapFree"              , SYSTEM.VAL(ADDRESS,HeapFree));
  Kernel.GetProcAddress(mod, "HeapSize"              , SYSTEM.VAL(ADDRESS,HeapSize));

  Kernel.GetProcAddress(mod, "GlobalAlloc"           , SYSTEM.VAL(ADDRESS,GlobalAlloc));
  Kernel.GetProcAddress(mod, "GlobalReAlloc"         , SYSTEM.VAL(ADDRESS,GlobalReAlloc));
  Kernel.GetProcAddress(mod, "GlobalSize"            , SYSTEM.VAL(ADDRESS,GlobalSize));
  Kernel.GetProcAddress(mod, "GlobalLock"            , SYSTEM.VAL(ADDRESS,GlobalLock));
  Kernel.GetProcAddress(mod, "GlobalUnlock"          , SYSTEM.VAL(ADDRESS,GlobalUnlock));
  Kernel.GetProcAddress(mod, "GlobalFree"            , SYSTEM.VAL(ADDRESS,GlobalFree));

  str := "USER32.DLL";
  mod := Kernel.LoadLibrary(str);

  Kernel.GetProcAddress(mod, "AdjustWindowRectEx"    , SYSTEM.VAL(ADDRESS,AdjustWindowRectEx));
  Kernel.GetProcAddress(mod, "ClientToScreen"        , SYSTEM.VAL(ADDRESS,ClientToScreen ));
  Kernel.GetProcAddress(mod, "CloseClipboard"        , SYSTEM.VAL(ADDRESS,CloseClipboard));
  Kernel.GetProcAddress(mod, "CreateCaret"           , SYSTEM.VAL(ADDRESS,CreateCaret));
  Kernel.GetProcAddress(mod, "CreateWindowExA"       , SYSTEM.VAL(ADDRESS,CreateWindowEx));
  Kernel.GetProcAddress(mod, "DefWindowProcA"        , SYSTEM.VAL(ADDRESS,DefWindowProc));
  Kernel.GetProcAddress(mod, "DestroyCaret"          , SYSTEM.VAL(ADDRESS,DestroyCaret));
  Kernel.GetProcAddress(mod, "DestroyWindow"         , SYSTEM.VAL(ADDRESS,DestroyWindow));
  Kernel.GetProcAddress(mod, "DispatchMessageA"      , SYSTEM.VAL(ADDRESS,DispatchMessage));
  Kernel.GetProcAddress(mod, "EmptyClipboard"        , SYSTEM.VAL(ADDRESS,EmptyClipboard));
  Kernel.GetProcAddress(mod, "EnableWindow"          , SYSTEM.VAL(ADDRESS,EnableWindow));
  Kernel.GetProcAddress(mod, "FillRect"              , SYSTEM.VAL(ADDRESS,FillRect));
  Kernel.GetProcAddress(mod, "GetActiveWindow"       , SYSTEM.VAL(ADDRESS,GetActiveWindow));
  Kernel.GetProcAddress(mod, "GetClassLongA"         , SYSTEM.VAL(ADDRESS,GetClassLong));
  Kernel.GetProcAddress(mod, "GetClientRect"         , SYSTEM.VAL(ADDRESS,GetClientRect));
  Kernel.GetProcAddress(mod, "GetClipboardData"      , SYSTEM.VAL(ADDRESS,GetClipboardData ));
  Kernel.GetProcAddress(mod, "GetCursorPos"          , SYSTEM.VAL(ADDRESS,GetCursorPos ));
  Kernel.GetProcAddress(mod, "GetDC"                 , SYSTEM.VAL(ADDRESS,GetDC ));
  Kernel.GetProcAddress(mod, "GetFocus"              , SYSTEM.VAL(ADDRESS,GetFocus));
  Kernel.GetProcAddress(mod, "GetMessageA"           , SYSTEM.VAL(ADDRESS,GetMessage));
  Kernel.GetProcAddress(mod, "GetPropA"              , SYSTEM.VAL(ADDRESS,GetProp));
  Kernel.GetProcAddress(mod, "GetSysColor"           , SYSTEM.VAL(ADDRESS,GetSysColor ));
  Kernel.GetProcAddress(mod, "GetWindowRect"         , SYSTEM.VAL(ADDRESS,GetWindowRect));
  Kernel.GetProcAddress(mod, "HideCaret"             , SYSTEM.VAL(ADDRESS,HideCaret));
  Kernel.GetProcAddress(mod, "InvalidateRect"        , SYSTEM.VAL(ADDRESS,InvalidateRect));
  Kernel.GetProcAddress(mod, "KillTimer"             , SYSTEM.VAL(ADDRESS,KillTimer));
  Kernel.GetProcAddress(mod, "LoadCursorA"           , SYSTEM.VAL(ADDRESS,LoadCursor));
  Kernel.GetProcAddress(mod, "LoadIconA"             , SYSTEM.VAL(ADDRESS,LoadIcon));
  Kernel.GetProcAddress(mod, "LoadImageA"            , SYSTEM.VAL(ADDRESS,LoadImage ));
  Kernel.GetProcAddress(mod, "MessageBoxA"           , SYSTEM.VAL(ADDRESS,MessageBox));
  Kernel.GetProcAddress(mod, "MoveWindow"            , SYSTEM.VAL(ADDRESS,MoveWindow));
  Kernel.GetProcAddress(mod, "OpenClipboard"         , SYSTEM.VAL(ADDRESS,OpenClipboard));
  Kernel.GetProcAddress(mod, "PostQuitMessage"       , SYSTEM.VAL(ADDRESS,PostQuitMessage));
  Kernel.GetProcAddress(mod, "RegisterClassExA"      , SYSTEM.VAL(ADDRESS,RegisterClassEx));
  Kernel.GetProcAddress(mod, "ReleaseCapture"        , SYSTEM.VAL(ADDRESS,ReleaseCapture ));
  Kernel.GetProcAddress(mod, "ReleaseDC"             , SYSTEM.VAL(ADDRESS,ReleaseDC ));
  Kernel.GetProcAddress(mod, "ScreenToClient"        , SYSTEM.VAL(ADDRESS,ScreenToClient ));
  Kernel.GetProcAddress(mod, "SendMessageA"          , SYSTEM.VAL(ADDRESS,SendMessage ));
  Kernel.GetProcAddress(mod, "SetCaretPos"           , SYSTEM.VAL(ADDRESS,SetCaretPos ));
  Kernel.GetProcAddress(mod, "SetCapture"            , SYSTEM.VAL(ADDRESS,SetCapture ));
  Kernel.GetProcAddress(mod, "SetClassLongA"         , SYSTEM.VAL(ADDRESS,SetClassLong));
  Kernel.GetProcAddress(mod, "SetClipboardData"      , SYSTEM.VAL(ADDRESS,SetClipboardData ));
  Kernel.GetProcAddress(mod, "SetCursor"             , SYSTEM.VAL(ADDRESS,SetCursor ));
  Kernel.GetProcAddress(mod, "SetFocus"              , SYSTEM.VAL(ADDRESS,SetFocus));
  Kernel.GetProcAddress(mod, "SetPropA"              , SYSTEM.VAL(ADDRESS,SetProp));
  Kernel.GetProcAddress(mod, "SetTimer"              , SYSTEM.VAL(ADDRESS,SetTimer));
  Kernel.GetProcAddress(mod, "SetWindowLongA"        , SYSTEM.VAL(ADDRESS,SetWindowLong ));
  Kernel.GetProcAddress(mod, "SetWindowPos"          , SYSTEM.VAL(ADDRESS,SetWindowPos));
  Kernel.GetProcAddress(mod, "SetWindowRgn"          , SYSTEM.VAL(ADDRESS,SetWindowRgn ));
  Kernel.GetProcAddress(mod, "ShowCaret"             , SYSTEM.VAL(ADDRESS,ShowCaret));
  Kernel.GetProcAddress(mod, "SystemParametersInfoA" , SYSTEM.VAL(ADDRESS,SystemParametersInfo));
  Kernel.GetProcAddress(mod, "ShowWindow"            , SYSTEM.VAL(ADDRESS,ShowWindow));
  Kernel.GetProcAddress(mod, "TrackMouseEvent"       , SYSTEM.VAL(ADDRESS,TrackMouseEvent ));
  Kernel.GetProcAddress(mod, "TranslateMessage"      , SYSTEM.VAL(ADDRESS,TranslateMessage));
  Kernel.GetProcAddress(mod, "UpdateWindow"          , SYSTEM.VAL(ADDRESS,UpdateWindow ));
  Kernel.GetProcAddress(mod, "UnregisterClassA"      , SYSTEM.VAL(ADDRESS,UnregisterClass));

  str := "GDI32.DLL";
  mod := Kernel.LoadLibrary(str);
  Kernel.GetProcAddress(mod, "Arc"                   , SYSTEM.VAL(ADDRESS,Arc ));
  Kernel.GetProcAddress(mod, "BitBlt"                , SYSTEM.VAL(ADDRESS,BitBlt ));
  Kernel.GetProcAddress(mod, "CombineRgn"            , SYSTEM.VAL(ADDRESS,CombineRgn ));
  Kernel.GetProcAddress(mod, "CreateCompatibleDC"    , SYSTEM.VAL(ADDRESS,CreateCompatibleDC ));
  Kernel.GetProcAddress(mod, "CreateDIBSection"      , SYSTEM.VAL(ADDRESS,CreateDIBSection));
  Kernel.GetProcAddress(mod, "CreateFontA"           , SYSTEM.VAL(ADDRESS,CreateFont ));
  Kernel.GetProcAddress(mod, "CreateFontIndirectA"   , SYSTEM.VAL(ADDRESS,CreateFontIndirect ));
  Kernel.GetProcAddress(mod, "CreatePen"             , SYSTEM.VAL(ADDRESS,CreatePen ));
  Kernel.GetProcAddress(mod, "CreateRectRgn"         , SYSTEM.VAL(ADDRESS,CreateRectRgn ));
  Kernel.GetProcAddress(mod, "CreateRoundRectRgn"    , SYSTEM.VAL(ADDRESS,CreateRoundRectRgn ));
  Kernel.GetProcAddress(mod, "CreateSolidBrush"      , SYSTEM.VAL(ADDRESS,CreateSolidBrush));
  Kernel.GetProcAddress(mod, "DeleteDC"              , SYSTEM.VAL(ADDRESS,DeleteDC));
  Kernel.GetProcAddress(mod, "DeleteObject"          , SYSTEM.VAL(ADDRESS,DeleteObject));
  Kernel.GetProcAddress(mod, "ExtTextOutA"           , SYSTEM.VAL(ADDRESS,ExtTextOut));
  Kernel.GetProcAddress(mod ,"GetCharWidthA"         , SYSTEM.VAL(ADDRESS,GetCharWidth ));
  Kernel.GetProcAddress(mod ,"GetDIBits"             , SYSTEM.VAL(ADDRESS,GetDIBits ));
  Kernel.GetProcAddress(mod, "GetObjectA"            , SYSTEM.VAL(ADDRESS,GetObject ));
  Kernel.GetProcAddress(mod, "GetStockObject"        , SYSTEM.VAL(ADDRESS,GetStockObject ));
  Kernel.GetProcAddress(mod, "GetTextExtentPoint32A" , SYSTEM.VAL(ADDRESS,GetTextExtentPoint32 ));
  Kernel.GetProcAddress(mod, "LineTo"                , SYSTEM.VAL(ADDRESS,LineTo ));
  Kernel.GetProcAddress(mod, "MoveToEx"              , SYSTEM.VAL(ADDRESS,MoveToEx ));
  Kernel.GetProcAddress(mod, "PatBlt"                , SYSTEM.VAL(ADDRESS,PatBlt ));
  Kernel.GetProcAddress(mod, "SelectObject"          , SYSTEM.VAL(ADDRESS,SelectObject ));
  Kernel.GetProcAddress(mod, "SetBkMode"             , SYSTEM.VAL(ADDRESS,SetBkMode ));
  Kernel.GetProcAddress(mod, "SetTextColor"          , SYSTEM.VAL(ADDRESS,SetTextColor ));
  Kernel.GetProcAddress(mod, "StretchBlt"            , SYSTEM.VAL(ADDRESS,StretchBlt ));

  str := "COMDLG32.DLL";
  mod := Kernel.LoadLibrary(str);
  Kernel.GetProcAddress(mod, "ChooseColorA"          , SYSTEM.VAL(ADDRESS,ChooseColor ));
  Kernel.GetProcAddress(mod, "ChooseFontA"           , SYSTEM.VAL(ADDRESS,ChooseFont ));
  Kernel.GetProcAddress(mod, "GetOpenFileNameA"      , SYSTEM.VAL(ADDRESS,GetOpenFileName ));
  Kernel.GetProcAddress(mod, "GetSaveFileNameA"      , SYSTEM.VAL(ADDRESS,GetSaveFileName ));
  Kernel.GetProcAddress(mod, "PrintDlgA"             , SYSTEM.VAL(ADDRESS,PrintDlg ));

END Windows.
